<?php

class arf_dig_pro_user_products {

	function __construct() {

		add_action( 'wp_ajax_arf_dig_pro_user_product_bulk_act', array( $this, 'arf_dig_pro_user_product_bulk_act' ) );	

		add_action( 'wp_ajax_arf_dig_pro_delete_user_product', array( $this, 'arf_dig_pro_single_delete_user_product' ) );
	}

	function arf_dig_pro_get_user_payment_detail( $payment_option, $form_id, $entry_id, $download_id ) {
		global $wpdb,$arfform,$arf_version,$MdlDb;

		if ( empty( $form_id ) || empty( $entry_id ) || empty( $download_id ) ) {
			return false;
		}

		$as__transaction     = array();
		$as__payment_options = maybe_unserialize( $payment_option );

		if ( ! empty( $as__payment_options ) ) {

			foreach ( $as__payment_options as $payment_type => $payment ) {

				if ( $payment_type == 'paypal' ) {
					if ( $payment->form_id == $form_id ) {
						$as__transaction[ $download_id ]['payment_method'] = 'PayPal';

						if( version_compare( $arf_version, '4.3', '<' ) ){

							$as__paypal_data = $wpdb->get_row( $wpdb->prepare( 'SELECT * FROM  ' . $wpdb->prefix . 'arf_paypal_order WHERE entry_id = %d AND form_id  = %d', array( $entry_id, $form_id ) ) );
						}else{

							$tblnm = $wpdb->prefix . 'arf_paypal_order ppl LEFT JOIN ' . $MdlDb->forms . ' frm ON ppl.form_id = frm.id';
							$as__paypal_data = $arfform->arf_select_db_data( true, '', $tblnm, 'ppl.*', 'WHERE ppl.entry_id = %d AND ppl.form_id  = %d', array( $entry_id, $form_id ), '', '', '', false, true );
						}

						if ( $as__paypal_data ) {
							$as__transaction[ $download_id ]['txn_id'] = $as__paypal_data->txn_id;
							if ( isset( $as__paypal_data->payment_type ) and $as__paypal_data->payment_type == 1 ) {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Donations', 'ARForms-Digital-Product' );
							} elseif ( isset( $as__paypal_data->payment_type ) and $as__paypal_data->payment_type == 2 ) {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Subscription', 'ARForms-Digital-Product' );
							} else {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Product / Service', 'ARForms-Digital-Product' );
							}
							$as__transaction[ $download_id ]['payment_status'] = $as__paypal_data->payment_status;
							$as__transaction[ $download_id ]['total_amount']   = $as__paypal_data->mc_gross;
							$as__transaction[ $download_id ]['currency']       = $as__paypal_data->mc_currency;
							$as__transaction[ $download_id ]['created_at']     = ( isset( $as__paypal_data->created_at ) && ! empty( $as__paypal_data->created_at ) ) ? date( get_option( 'date_format' ), strtotime( $as__paypal_data->created_at ) ) : '';
						}
					}
				}

				if ( $payment_type == 'paypal_pro' ) {
					if ( $payment->form_id == $form_id ) {
						$as__transaction[ $download_id ]['payment_method'] = 'Paypal Pro';
						
						if( version_compare( $arf_version, '4.3', '<' ) ){

							$as__paypal_pro_data = $wpdb->get_row( $wpdb->prepare( 'SELECT * FROM  ' . $wpdb->prefix . 'arf_paypalpro_order WHERE entry_id = %d AND form_id  = %d', array( $entry_id, $form_id ) ) );
						}else{

							$tblnm = $wpdb->prefix . 'arf_paypalpro_order pylr LEFT JOIN ' . $MdlDb->forms . ' frm ON pylr.form_id = frm.id';
							$as__paypal_pro_data = $arfform->arf_select_db_data( true, '', $tblnm, 'pylr.*', 'WHERE pylr.entry_id = %d AND pylr.form_id  = %d', array( $entry_id, $form_id ), '', '', '', false, true);
						}

						if ( $as__paypal_pro_data ) {
							$as__transaction[ $download_id ]['txn_id'] = $as__paypal_pro_data->txn_id;
							if ( isset( $as__paypal_pro_data->payment_type ) and $as__paypal_pro_data->payment_type == 1 ) {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Donations', 'ARForms-Digital-Product' );
							} elseif ( isset( $as__paypal_pro_data->payment_type ) and $as__paypal_pro_data->payment_type == 2 ) {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Subscription', 'ARForms-Digital-Product' );
							} else {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Product / Service', 'ARForms-Digital-Product' );
							}
							$as__transaction[ $download_id ]['payment_status'] = $as__paypal_pro_data->payment_status;
							$as__transaction[ $download_id ]['total_amount']   = $as__paypal_pro_data->mc_gross;
							$as__transaction[ $download_id ]['currency']       = $as__paypal_pro_data->mc_currency;
							$as__transaction[ $download_id ]['created_at']     = ( isset( $as__paypal_pro_data->created_at ) && ! empty( $as__paypal_pro_data->created_at ) ) ? date( get_option( 'date_format' ), strtotime( $as__paypal_pro_data->created_at ) ) : '';
						}
					}
				}

				if ( $payment_type == 'authorize_net' ) {
					if ( $payment->form_id == $form_id ) {
						$as__transaction[ $download_id ]['payment_method'] = 'Authorize Net';

						if( version_compare( $arf_version, '4.3', '<' ) ){

							$as__authorize_net_data = $wpdb->get_row( $wpdb->prepare( 'SELECT * FROM  ' . $wpdb->prefix . 'arf_authorizenet_order WHERE entry_id = %d AND form_id  = %d', array( $entry_id, $form_id ) ) );
						}else{

							$tblnm = $wpdb->prefix . 'arf_authorizenet_order auth LEFT JOIN ' . $MdlDb->forms . ' frm ON auth.form_id = frm.id';
							$as__authorize_net_data = $arfform->arf_select_db_data( true, '', $tblnm, 'auth.*', 'WHERE auth.entry_id = %d AND auth.form_id  = %d', array($entry_id, $form_id), '', '', '', false, true);
						}

						if ( $as__authorize_net_data ) {
							$as__transaction[ $download_id ]['txn_id'] = $as__authorize_net_data->txn_id;
							if ( isset( $as__paypal_pro_data->payment_type ) and $as__authorize_net_data->payment_type == 1 ) {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Donations', 'ARForms-Digital-Product' );
							} elseif ( isset( $as__paypal_pro_data->payment_type ) and $as__authorize_net_data->payment_type == 2 ) {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Subscription', 'ARForms-Digital-Product' );
							} else {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Product / Service', 'ARForms-Digital-Product' );
							}
							$as__transaction[ $download_id ]['payment_status'] = $as__authorize_net_data->payment_status;
							$as__transaction[ $download_id ]['total_amount']   = $as__authorize_net_data->mc_gross;
							$as__transaction[ $download_id ]['currency']       = $as__authorize_net_data->mc_currency;
							$as__transaction[ $download_id ]['created_at']     = ( isset( $as__authorize_net_data->created_at ) && ! empty( $as__authorize_net_data->created_at ) ) ? date( get_option( 'date_format' ), strtotime( $as__authorize_net_data->created_at ) ) : '';
						}
					}
				}

				if ( $payment_type == 'stripe' ) {
					if ( $payment->form_id == $form_id ) {
						$as__transaction[ $download_id ]['payment_method'] = 'Stripe';

						if( version_compare( $arf_version, '4.3', '<' ) ){

							$as__stripe_data = $wpdb->get_row( $wpdb->prepare( 'SELECT * FROM  ' . $wpdb->prefix . 'arf_stripe_order WHERE entry_id = %d AND form_id  = %d', array( $entry_id, $form_id ) ) );

						}else{

							$tblnm = $wpdb->prefix . 'arf_stripe_order strp LEFT JOIN ' . $MdlDb->forms . ' frm ON strp.form_id = frm.id';
							$as__stripe_data = $arfform->arf_select_db_data( true, '', $tblnm, 'strp.*', 'WHERE strp.entry_id = %d AND strp.form_id  = %d', array( $entry_id, $form_id ), '', '', '', false, true);
						}

						if ( $as__stripe_data ) {
							$as__transaction[ $download_id ]['txn_id'] = $as__stripe_data->txn_id;
							if ( isset( $as__paypal_pro_data->payment_type ) and $as__paypal_pro_data->payment_type == 1 ) {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Subscription', 'ARForms-Digital-Product' );
							} else {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Product / Service', 'ARForms-Digital-Product' );
							}
							$as__transaction[ $download_id ]['payment_status'] = $as__stripe_data->payment_status;
							$as__transaction[ $download_id ]['total_amount']   = $as__stripe_data->mc_gross;
							$as__transaction[ $download_id ]['currency']       = $as__stripe_data->mc_currency;
							$as__transaction[ $download_id ]['created_at']     = ( isset( $as__stripe_data->created_at ) && ! empty( $as__stripe_data->created_at ) ) ? date( get_option( 'date_format' ), strtotime( $as__stripe_data->created_at ) ) : '';
						}
					}
				}

				if ( $payment_type == 'mollie' ) {
					if ( $payment->form_id == $form_id ) {
						$as__transaction[ $download_id ]['payment_method'] = 'Mollie';

						if( version_compare( $arf_version, '4.3', '<' ) ){

							$as__mollie_data = $wpdb->get_row( $wpdb->prepare( 'SELECT * FROM  ' . $wpdb->prefix . 'arf_mollie_order WHERE entry_id = %d AND form_id  = %d', array( $entry_id, $form_id ) ) );

						}else{

							$tblnm = $wpdb->prefix . 'arf_mollie_order moli LEFT JOIN ' . $MdlDb->forms . ' frm ON moli.form_id = frm.id';
							$as__mollie_data = $arfform->arf_select_db_data( true, '', $tblnm, 'moli.*', 'WHERE moli.entry_id = %d AND moli.form_id  = %d', array( $entry_id, $form_id ), '', '', '', false, true);
						}

						if ( $as__mollie_data ) {
							$as__transaction[ $download_id ]['txn_id'] = $as__mollie_data->txn_id;
							if ( isset( $as__mollie_data->payment_type ) and $as__mollie_data->payment_type == 1 ) {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Subscription', 'ARForms-Digital-Product' );
							} else {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Product / Service', 'ARForms-Digital-Product' );
							}
							$as__transaction[ $download_id ]['payment_status'] = $as__mollie_data->payment_status;
							$as__transaction[ $download_id ]['total_amount']   = $as__mollie_data->mc_gross;
							$as__transaction[ $download_id ]['currency']       = $as__mollie_data->mc_currency;
							$as__transaction[ $download_id ]['created_at']     = ( isset( $as__mollie_data->created_at ) && ! empty( $as__mollie_data->created_at ) ) ? date( get_option( 'date_format' ), strtotime( $as__stripe_data->created_at ) ) : '';
						}
					}
				}

				if ( $payment_type == 'pagseguro' ) {
					if ( $payment->form_id == $form_id ) {
						$as__transaction[ $download_id ]['payment_method'] = 'Pagseguro';

						if( version_compare( $arf_version, '4.3', '<' ) ){

							$as__pagseguro_data = $wpdb->get_row( $wpdb->prepare( 'SELECT * FROM  ' . $wpdb->prefix . 'arf_pagseguro_order WHERE entry_id = %d AND form_id  = %d', array( $entry_id, $form_id ) ) );

						}else{

							$tblnm = $wpdb->prefix . 'arf_pagseguro_order pgse LEFT JOIN ' . $MdlDb->forms . ' frm ON pgse.form_id = frm.id';
							$as__pagseguro_data = $arfform->arf_select_db_data( true, '', $tblnm, 'pgse.*', 'WHERE pgse.entry_id = %d AND pgse.form_id  = %d', array( $entry_id, $form_id ), '', '', '', false, true);
						}

						if ( $as__pagseguro_data ) {
							$as__transaction[ $download_id ]['txn_id'] = $as__pagseguro_data->txn_id;
							if ( isset( $as__pagseguro_data->payment_type ) and $as__pagseguro_data->payment_type == 1 ) {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Subscription', 'ARForms-Digital-Product' );
							} else {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Product / Service', 'ARForms-Digital-Product' );
							}
							$as__transaction[ $download_id ]['payment_status'] = $as__pagseguro_data->payment_status;
							$as__transaction[ $download_id ]['total_amount']   = $as__pagseguro_data->mc_gross;
							$as__transaction[ $download_id ]['currency']       = $as__pagseguro_data->mc_currency;
							$as__transaction[ $download_id ]['created_at']     = ( isset( $as__pagseguro_data->created_at ) && ! empty( $as__pagseguro_data->created_at ) ) ? date( get_option( 'date_format' ), strtotime( $as__pagseguro_data->created_at ) ) : '';
						}
					}
				}

				if ( $payment_type == 'payfast' ) {
					if ( $payment->form_id == $form_id ) {
						$as__transaction[ $download_id ]['payment_method'] = 'Payfast';

						if( version_compare( $arf_version, '4.3', '<' ) ){

							$as__payfast_data = $wpdb->get_row( $wpdb->prepare( 'SELECT * FROM  ' . $wpdb->prefix . 'arf_payfast_order WHERE entry_id = %d AND form_id  = %d', array( $entry_id, $form_id ) ) );

						}else{

							$tblnm = $wpdb->prefix . 'arf_payfast_order pyfs LEFT JOIN ' . $MdlDb->forms . ' frm ON pyfs.form_id = frm.id';
							$as__payfast_data = $arfform->arf_select_db_data( true, '', $tblnm, 'pyfs.*', 'WHERE pyfs.entry_id = %d AND pyfs.form_id  = %d', array( $entry_id, $form_id ), '', '', '', false, true);
						}

						if ( $as__payfast_data ) {
							$as__transaction[ $download_id ]['txn_id'] = $as__payfast_data->txn_id;
							if ( isset( $as__payfast_data->payment_type ) and $as__payfast_data->payment_type == 1 ) {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Subscription', 'ARForms-Digital-Product' );
							} else {
								$as__transaction[ $download_id ]['payment_type'] = esc_html__( 'Product / Service', 'ARForms-Digital-Product' );
							}
							$as__transaction[ $download_id ]['payment_status'] = $as__payfast_data->payment_status;
							$as__transaction[ $download_id ]['total_amount']   = $as__payfast_data->mc_gross;
							$as__transaction[ $download_id ]['currency']       = $as__payfast_data->mc_currency;
							$as__transaction[ $download_id ]['created_at']     = ( isset( $as__payfast_data->created_at ) && ! empty( $as__payfast_data->created_at ) ) ? date( get_option( 'date_format' ), strtotime( $as__payfast_data->created_at ) ) : '';
						}
					}
				}
			}
		}
		return $as__transaction;
	}

	function arf_dig_pro_user_product_bulk_act() {

		if ( ! isset( $_POST ) ) {
			return;
		}
		global $arfform,$armainhelper, $arf_version;

		$bulkaction = $armainhelper->get_param( 'action1' );

		$message = '';

		$errors = array();

		if ( $bulkaction == -1 ) {
			$bulkaction = $armainhelper->get_param( 'action2' );
		}

		if ( ! empty( $bulkaction ) and strpos( $bulkaction, 'bulk_' ) === 0 ) {

			if ( isset( $_GET ) and isset( $_GET['action1'] ) ) {
				$_SERVER['REQUEST_URI'] = str_replace( '&action=' . $_GET['action1'], '', $_SERVER['REQUEST_URI'] );
			}

			if ( isset( $_GET ) and isset( $_GET['action2'] ) ) {
				$_SERVER['REQUEST_URI'] = str_replace( '&action=' . $_GET['action2'], '', $_SERVER['REQUEST_URI'] );
			}

			$bulkaction = str_replace( 'bulk_', '', $bulkaction );
		} else {

			$bulkaction = '-1';

			if ( isset( $_POST['bulkaction'] ) and $_POST['bulkaction1'] != '-1' ) {
				$bulkaction = $_POST['bulkaction1'];

			} elseif ( isset( $_POST['bulkaction2'] ) and $_POST['bulkaction2'] != '-1' ) {
				$bulkaction = $_POST['bulkaction2'];
			}
		}

		$ids = $armainhelper->get_param( 'item-action', '' );

		if ( empty( $ids ) ) {
			$errors[] = esc_html__( 'Please select one or more records.', 'ARForms-Digital-Product' );
		} else {
			if ( ! is_array( $ids ) ) {
				$ids = explode( ',', $ids );
			}

			if ( is_array( $ids ) ) {
				if ( $bulkaction == 'delete' ) {
					foreach ( $ids as $fid ) {
						$res_var = $this->arf_dig_pro_delete_user_product( $fid );
					}
					if ( $res_var ) {
						$message = esc_html__( 'Record is deleted successfully.', 'ARForms-Digital-Product' );
					}
				} else {
					$errors[] = esc_html__( 'Please select one or more records.', 'ARForms-Digital-Product' );
				}
			}
		}
		

		if ( version_compare( $arf_version, '5.0', '>' ) ) {
			global $wpdb, $MdlDb, $arformcontroller;
			echo json_encode(
				array(
					'errors'   => $errors,
					'message'  => $message,
				)
			);
		} else {
			$arf_dig_pro_user_product_data = $this->arf_dig_product_user_product_listing( $message, $errors );	
			echo json_encode(
				array(
					'errors'   => $errors,
					'message'  => $message,
					'gridData' => $arf_dig_pro_user_product_data,
				)
			);
		}

		

		die();
	}


	function arf_dig_product_user_product_listing( $message = '', $errors = array() ){

		global $wpdb ,$arf_dig_pro_user_products_class ,$arf_digital_product_download_tbl ,$arf_digital_product_tbl, $arf_version, $arfform;

		$as___payment = array();

		$actions['bulk_delete'] = esc_html__( 'Delete', 'ARForms-Digital-Product' );

		if( version_compare( $arf_version, '4.3', '<' ) ){

			$products_bulk = $wpdb->get_results( 'SELECT D.*,P.options FROM ' . $arf_digital_product_download_tbl . ' AS D LEFT JOIN  ' . $arf_digital_product_tbl . ' AS P ON D.product_id = P.id ORDER BY D.id DESC' );
		}else{

			$tblnm = $arf_digital_product_download_tbl . ' AS D LEFT JOIN  ' . $arf_digital_product_tbl . ' AS P ON D.product_id = P.id'; 
			$products_bulk = $arfform->arf_select_db_data( true, '', $tblnm, 'D.*,P.options', '', array(), '', 'ORDER BY D.id DESC');
		}
				
		$product_data_bulk_download = array();

		if ( count( $products_bulk ) > 0 ) {			
			$n = 0;
			foreach ( $products_bulk as $products ) {

				$options      = maybe_unserialize( $products->options );

				$as___payment = $arf_dig_pro_user_products_class->arf_dig_pro_get_user_payment_detail( $products->payment_options, $products->form_id, $products->entry_id, $products->id );

				if ( ! isset( $product_data_bulk_download[ $n ] ) ) {
					$product_data_bulk_download[ $n ] = array();
				}

				$product_data_bulk_download[ $n ][] = '<div class="arf_custom_checkbox_div">
				<div class="arf_custom_checkbox_wrapper">
					<input id="cb-item-action-' . $products->id .'" class="" type="checkbox" value="' .$products->id .'" name="item-action[]"><svg width="18px" height="18px">'.ARF_CUSTOM_UNCHECKED_ICON . ARF_CUSTOM_CHECKED_ICON .'</svg></div></div><label for="cb-item-action-' . $products->id . '"><span></span></label>';

				$product_data_bulk_download[ $n ][] = $products->id;
				$product_data_bulk_download[ $n ][] = $products->product_id;
				$product_data_bulk_download[ $n ][] = $products->form_id;
				$product_data_bulk_download[ $n ][] = $products->entry_id;
				$product_data_bulk_download[ $n ][] = isset( $as___payment[$products->id]['txn_id'] ) ? esc_html( $as___payment[$products->id]['txn_id'] ) : ''; 

				$product_data_bulk_download[ $n ][] = '<a class="row-title" href="'. esc_url( wp_nonce_url( '?page=ARForms-DigitalProduct&arfaction=edit&id='. $products-> product_id ) ).'">'. $options['arf_product_name'] .'</a>';


				$product_data_bulk_download[ $n ][] = isset( $as___payment[ $products->id ]['payment_type'] ) ? esc_html( $as___payment[ $products->id ]['payment_type'] ) : ''; 
				$product_data_bulk_download[ $n ][] = isset( $as___payment[ $products->id ]['payment_method'] ) ? esc_html( $as___payment[ $products->id ]['payment_method'] ) : ''; 
			
 				$product_data_bulk_download[ $n ][] = isset( $as___payment[ $products->id ]['total_amount'] ) ? esc_html ( $as___payment[ $products->id ]['total_amount'] ) . '&nbsp;' . esc_html( $as___payment[ $products->id ]['currency'] ) : ''; //amount


				$product_data_bulk_download[ $n ][] = ( isset( $as___payment[ $products->id ]['payment_status'] ) && isset( $as___payment[ $products->id ]['currency'] ) ) ? esc_html( $as___payment[ $products->id ]['payment_status'] ) : ''; //status

				$product_data_bulk_download[ $n ][] = date( get_option( 'date_format' ), strtotime( $products->created_at ) );

				$edit_link = '?page=ARForms-DigitalProduct&arfaction=edit&id=' . $products->id;

				$arf_action_div_history = '<div class="arf-row-actions arf_digpro_action_cell " >';

				$arf_action_div_history .= "<div class='arfformicondiv arfhelptip' title='" . esc_html__( 'View Entry', 'ARForms-Digital-Product' ) . "'><a href='javascript:void(0);' onclick='open_entry_thickbox({$products->id});'><svg width='30px' height='30px' viewBox='-3 -8 32 32' class='arfsvgposition'><path fill-rule='evenodd' clip-rule='evenodd' fill='#ffffff' d='M12.993,15.23c-7.191,0-11.504-7.234-11.504-7.234  S5.801,0.85,12.993,0.85c7.189,0,11.504,7.19,11.504,7.19S20.182,15.23,12.993,15.23z M12.993,2.827  c-5.703,0-8.799,5.214-8.799,5.214s3.096,5.213,8.799,5.213c5.701,0,8.797-5.213,8.797-5.213S18.694,2.827,12.993,2.827z   M12.993,11.572c-1.951,0-3.531-1.581-3.531-3.531s1.58-3.531,3.531-3.531c1.949,0,3.531,1.581,3.531,3.531  S14.942,11.572,12.993,11.572z'/></svg></a></div>";

				$arf_action_div_history .= "<div class='arfformicondiv arfhelptip arfdeleteentry_div_" . $products->id . "' title='" . esc_html__( 'Delete', 'ARForms-Digital-Product' ) . "'><a  data-id='" . $products->id . "' class='arfformentry_delete arf_digpro_cursor_pointer'><svg width='30px' height='30px' viewBox='-5 -5 32 32' class='arfsvgposition'><path fill-rule='evenodd' clip-rule='evenodd' fill='#ffffff' d='M18.435,4.857L18.413,19.87L3.398,19.88L3.394,4.857H1.489V2.929  h1.601h3.394V0.85h8.921v2.079h3.336h1.601l0,0v1.928H18.435z M15.231,4.857H6.597H5.425l0.012,13.018h10.945l0.005-13.018H15.231z   M11.4,6.845h2.029v9.065H11.4V6.845z M8.399,6.845h2.03v9.065h-2.03V6.845z' /></svg></a></div>";

				$arf_action_div_history .= "<div id='view_entry_detail_container_{$products->id}' class='arf_display_none'>" . $arf_dig_pro_user_products_class->arf_dig_pro_get_download_history_entries_list( $products, $as___payment ) . "</div><div class='arfmnarginbtm10 arf_digpro_clear_both'></div>";

				$arf_action_div_history .= '</div>';

				$product_data_bulk_download[ $n ][] = $arf_action_div_history;

				$n++;
	}
}
	return $product_data_bulk_download;
}

	function arf_dig_pro_user_product_listing( $message = '', $errors = array() ) {
		global $wpdb, $arf_dig_pro_user_products_class;
		$actions['bulk_delete'] = esc_html__( 'Delete', 'ARForms-Digital-Product' );
		if ( file_exists( ARF_DIG_PRO_VIEWS_DIR . '/arf_dig_pro_download_product_listing_3.0.php' ) ) {
			require_once ARF_DIG_PRO_VIEWS_DIR . '/arf_dig_pro_download_product_listing_3.0.php';
		}
	}

	function arf_dig_pro_single_delete_user_product() {

		global $arf_version;		
		$id     = $_POST['id'];
		$action = $_POST['act'];
		$errors = array();

		if ( $action == 'delete' && $id ) {

			$res     = $this->arf_dig_pro_delete_user_product( $id );

			if ( ! $res ) {
				$err = esc_html__( 'Record is not deleted', 'ARForms-Digital-Product' );
				array_push( $errors, $err );
			} else {
				$message = esc_html__( 'Record is deleted successfully.', 'ARForms-Digital-Product' );
			}

			//$errors  = array();
			//$this->arf_dig_pro_user_product_listing( $message, $errors );
		}else{
			$err = esc_html__( 'Record is not deleted', 'ARForms-Digital-Product' );
			array_push( $errors, $err );
		}

		if ( version_compare( $arf_version, '5.0', '>' ) ) {
			global $wpdb, $MdlDb, $arformcontroller;
			echo json_encode(
				array(
					'errors'   => $errors,
					'message'  => $message,
				)
			);
		} else {
			$arf_dig_pro_user_product_data_new = $this->arf_dig_product_user_product_listing( $message, $errors );
			echo json_encode(
				array(
					'errors'   => $errors,
					'message'  => $message,
					'gridData' => $arf_dig_pro_user_product_data_new,
				)
			);	
		}
		
		die();
	}

	function arf_dig_pro_delete_user_product( $id = 0 ) {
		if ( $id == 0 ) {
			return;
		}
		if ( $id ) {
			global $wpdb,$arf_digital_product_download_tbl;
			$res = $wpdb->query( $wpdb->prepare( 'DELETE FROM ' . $arf_digital_product_download_tbl . ' WHERE id = %d', $id ) );
			return $res;
		}
	}

	function arf_dig_pro_get_download_history_entries_list( $download, $as___payment ) {

		if ( empty( $download ) ) {
			return false;
		}

		if ( is_rtl() ) {
			$txt_align = 'arf_digpro_text_align_right';
		} else {
			$txt_align = 'arf_digpro_text_align_left';
		}

		$options = maybe_unserialize( $download->options );

		$var = '<table class="form-table"><tbody>';

		$var .= '<tr class="arfviewentry_row" valign="top">';
		$var .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Download ID', 'ARForms-Digital-Product' ) . ':</strong></td>';
		$var .= '<td  class="arfviewentry_right ' . $txt_align . '">' . $download->id . '</td>';
		$var .= '</tr>';

		$var .= '<tr class="arfviewentry_row" valign="top">';
		$var .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Product ID', 'ARForms-Digital-Product' ) . ':</strong></td>';
		$var .= '<td  class="arfviewentry_right ' . $txt_align . '">' . $download->product_id . '</td>';
		$var .= '</tr>';

		$var .= '<tr class="arfviewentry_row" valign="top">';
		$var .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Form ID', 'ARForms-Digital-Product' ) . ':</strong></td>';
		$var .= '<td  class="arfviewentry_right ' . $txt_align . '">' . $download->form_id . '</td>';
		$var .= '</tr>';

		$var .= '<tr class="arfviewentry_row" valign="top">';
		$var .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Entry ID', 'ARForms-Digital-Product' ) . ':</strong></td>';
		$var .= '<td  class="arfviewentry_right ' . $txt_align . '">' . $download->entry_id . '</td>';
		$var .= '</tr>';

		$txn_id = ( isset( $as___payment[ $download->id ]['txn_id'] ) ) ? $as___payment[ $download->id ]['txn_id'] : '';
		$var   .= '<tr class="arfviewentry_row" valign="top">';
		$var   .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Transaction ID / Subscription ID', 'ARForms-Digital-Product' ) . ':</strong></td>';

		$var .= '<td  class="arfviewentry_right ' . $txt_align . '">' . $txn_id . '</td>';
		$var .= '</tr>';

		$var .= '<tr class="arfviewentry_row" valign="top">';
		$var .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Product Name', 'ARForms-Digital-Product' ) . ':</strong></td>';
		$var .= '<td  class="arfviewentry_right ' . $txt_align . '"><a class="row-title" href="' . wp_nonce_url( "?page=ARForms-DigitalProduct&arfaction=edit&id={$download->product_id}" ) . '">' . $options['arf_product_name'] . '</a></td>';
		$var .= '</tr>';

		$payment_type = isset( $as___payment[ $download->id ]['payment_type'] ) ? $as___payment[ $download->id ]['payment_type'] : '';
		$var         .= '<tr class="arfviewentry_row" valign="top">';
		$var         .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Payment Type', 'ARForms-Digital-Product' ) . ':</strong></td>';
		$var         .= '<td  class="arfviewentry_right ' . $txt_align . '">' . $payment_type . '</td>';
		$var         .= '</tr>';

		$payment_method = isset( $as___payment[ $download->id ]['payment_method'] ) ? $as___payment[ $download->id ]['payment_method'] : '';
		$var           .= '<tr class="arfviewentry_row" valign="top">';
		$var           .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Payment Method', 'ARForms-Digital-Product' ) . ':</strong></td>';
		$var           .= '<td  class="arfviewentry_right ' . $txt_align . '">' . $payment_method . '</td>';
		$var           .= '</tr>';

		$currency = ( isset( $as___payment[ $download->id ]['total_amount'] ) && isset( $as___payment[ $download->id ]['currency'] ) ) ? $as___payment[ $download->id ]['total_amount'] . '&nbsp;' . $as___payment[ $download->id ]['currency'] : '';
		$var     .= '<tr class="arfviewentry_row" valign="top">';
		$var     .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Amount', 'ARForms-Digital-Product' ) . ':</strong></td>';
		$var     .= '<td  class="arfviewentry_right ' . $txt_align . '">' . $currency . '</td>';
		$var     .= '</tr>';

		$payment_status = isset( $as___payment[ $download->id ]['payment_status'] ) ? $as___payment[ $download->id ]['payment_status'] : '';
		$var           .= '<tr class="arfviewentry_row" valign="top">';
		$var           .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Payment Status', 'ARForms-Digital-Product' ) . ':</strong></td>';
		$var           .= '<td  class="arfviewentry_right ' . $txt_align . '">' . $payment_status . '</td>';
		$var           .= '</tr>';

		$var .= '<tr class="arfviewentry_row" valign="top">';
		$var .= '<td class="arfviewentry_left" scope="row"><strong>' . esc_html__( 'Created Date', 'ARForms-Digital-Product' ) . ':</strong></td>';
		$var .= '<td  class="arfviewentry_right ' . $txt_align . '">' . date( get_option( 'date_format' ), strtotime( $download->created_at ) ) . '</td>';
		$var .= '</tr>';

		$var .= '</tbody></table>';
		return $var;
	}
}
