var arf_pdf_actions = [];
"use strict";
function arf_pdf_creator_add_action(action_name, callback, priority)
{
    if (! priority) {
        priority = 10;
    }
    if (priority > 100) {
        priority = 100;
    }
    if (priority < 0) {
        priority = 0;
    }
    if (typeof arf_pdf_actions[action_name] == 'undefined') {
        arf_pdf_actions[action_name] = [];
    }
    if (typeof arf_pdf_actions[action_name][priority] == 'undefined') {
        arf_pdf_actions[action_name][priority] = []
    }
    arf_pdf_actions[action_name][priority].push(callback);
    if ('undefined' != typeof window.arf_actions) {
        var arf_action_keys = Object.keys(window.arf_actions);
        if (arf_action_keys.length > 0) {
            window.arf_actions[action_name] = arf_pdf_actions[action_name];
        } else {
            window.arf_actions = arf_pdf_actions;
        }
    }
}
arf_pdf_creator_add_action('arf_update_name_dropdown_outside', 'add_fields_to_template_name_dropdown');
function add_fields_to_template_name_dropdown(){

    var params = arguments[0][0];
    var field_temp_data = arf_retrieve_field_data(params[0]);

    if( typeof field_temp_data.parent_field_type != 'undefined' && 'arf_repeater' == field_temp_data.parent_field_type ){
        return false;
    }
    var template_name_body = document.querySelectorAll("#add_field_template_name .arfmodal-body_p");
    var loop17_length = template_name_body.length;
    for (var i = 0; i < loop17_length; i++) {
        var $that17 = template_name_body[i];
        if (params[1] != 'divider' && params[1] != 'section' && params[1] != 'arf_repeater' && params[1] != 'break' && params[1] != 'captcha' && params[1] != 'html' && params[1] != 'imagecontrol' && params[1] != 'file' && params[1] != 'like' && params[1] != 'arf_product') {
            
            var flen = jQuery($that17).find('div[id="arfmodalfieldval_' + params[0] + '"]').length || 0;
            if (flen > 0) {
                $that17.querySelector('div[id="arfmodalfieldval_' + params[0] + '"]').innerHTML = params[2];
            } else {
                var tempDiv = document.createElement('div');
                tempDiv.setAttribute('class', 'modal_field_val');
                tempDiv.setAttribute('id', 'arfmodalfieldval_' + params[0]);
                tempDiv.setAttribute('onclick', "arfaddcodefornewfield('arf_pdfcreator_template_name','" + params[0] + "')");
                tempDiv.appendChild(document.createTextNode(params[2]));
                $that17.appendChild(tempDiv);
            }
        }
    }
}
arf_pdf_creator_add_action('arf_delete_name_dropdown_outside', 'delete_fields_to_template_name_dropdown');
function delete_fields_to_template_name_dropdown(){
    var params = arguments[0][0];
    var field_id = params[0];
    var pdf_template_nm_fields_list = '';
    pdf_template_nm_fields_list += "<div class='modal_field_val' id='arfmodalfieldval_extrafield' onclick='arfaddcodeforextrafield(\"arf_pdfcreator_template_name\", \"date\")'> Date </div> <div class='modal_field_val' id='arfmodalfieldval_extrafield' onclick='arfaddcodeforextrafield(\"arf_pdfcreator_template_name\", \"time\")'>Time</div><div class='modal_field_val' id='arfmodalfieldval_extrafield' onclick='arfaddcodeforextrafield(\"arf_pdfcreator_template_name\", \"entry_id\")'>Entry ID</div>";
    jQuery('div.sortable_inner_wrapper').not('#arfmainfieldid_' + field_id).each(function(j) {
        if ( ( jQuery(this).is(':visible') && jQuery(this).find('.arfformfield').length == 1 ) || ( jQuery(this).find('.arfformfield').length > 1 && jQuery(this).hasClass('edit_field_type_arf_repeater') ) ) {
            var id = jQuery(this).attr('id');
            id = id.replace('arfmainfieldid_', '');
            var f_id = id;
            if (jQuery(this).find('#field_confiorm_password').length > 0 || jQuery(this).find('#field_confiorm_email').length > 0) {
                return;
            }
            var new_name = arf_retrieve_field_data(id);
            var name = new_name.name;
            var type = new_name.type;
            if ( name === '' || name === null || name === undefined ) {
                name = jQuery('#field_' + id).text();
            }
            if( '' == name ){
                name = '[Field Id:'+f_id+']';
            }
            if( typeof new_name.has_parent != 'undefined' ){
                return;
            }
            if (type != 'divider' && type != 'section' && type != 'break' && type != 'captcha' && type != 'html' && type != 'imagecontrol' && type != 'file' && type != 'like' && type != 'arf_repeater' && type != 'arf_product' ) {
                pdf_template_nm_fields_list += '<div class="modal_field_val" id="arfmodalfieldval_' + f_id + '" onclick="arfaddcodefornewfield(\'arf_pdfcreator_template_name\',\'' + f_id + '\')">' + name + '</div>';
            }
            jQuery('#add_field_template_name .arfmodal-body_p').html(pdf_template_nm_fields_list);
        }
    });
}

function arfaddcodeforextrafield(element, variable) {
    var element_id = element;
    var variable2;
    variable2 = "{" + variable + "}";

    insertAtCaret(element_id, variable2);
}