<?php
global $arffield,$arf_postcreator,$arf_version,$maincontroller;
if ( isset( $_REQUEST['arfaction'] ) && 'edit' == $_REQUEST['arfaction'] ) {
	global $wpdb, $arfform, $is_version_compatible;

	if( version_compare( $arf_version, '4.3', '<' ) ){

		$form_data = $wpdb->get_results( $wpdb->prepare( 'SELECT * FROM ' . $wpdb->prefix . 'arf_postcreator_forms WHERE id = %d', $_REQUEST['id'] ) );

	} else{

		$form_data = $arfform->arf_select_db_data(true, '', $wpdb->prefix . 'arf_postcreator_forms', '*', 'WHERE id = %d', array($_REQUEST['id']));
	}

	if ( count( $form_data ) > 0 ) {

		$form_data = $form_data[0];

		$options = maybe_unserialize( $form_data->options );

		$values = array();

		$values['id'] = $form_data->id;

		$values['form_id'] = $form_data->form_id;

		$values['form_name'] = $form_data->form_name;

		if ( count( $options ) > 0 ) {
			foreach ( $options as $option_key => $option_val ) {
				$values[ $option_key ] = $option_val;
			}
		}

		$form_data_new = $arfform->getOne( $form_data->form_id );

		$form_options = maybe_unserialize( $form_data_new->options );

		$arfaction = 'edit';

	} else {
		$redirect = admin_url( 'admin.php?page=ARForms-postcreator&err=true' );
		echo "<input type='hidden' id='arf_postcreator_error' value='true' data-url='" . $redirect . "' />";
	}
} else {
	$values['post_type']         = 'basic';
	$values['custom_post']       = '';
	$values['id']                = '';
	$values['form_id']           = '';
	$values['form_name']         = '';
	$values['title']             = '';
	$values['description']       = '';
	$values['excerpt']           = '';
	$values['author']            = 'default';
	$values['date']              = 'default';
	$values['status']            = 'publish';
	$values['image']             = '';
	$values['tag']               = '';
	$values['categories']        = array();
	$values['arf_allow_comment'] = '';
	$values['bp_group_name']     = '';
	$values['bp_group_name_array'] = array();

	$arfaction = 'new';
}

$field_array = array();
if ( !empty($values['form_id'])) {
	$field_array = $arffield->getAll( 'fi.form_id=' . (int) $values['form_id'], 'fi.id' );
}

?>
<div class="wrap postcreator_page">
	
	<div id="success_message" class="arf_success_message">
		<div class="message_descripiton">
			<div id="message_desc_text"></div>
			<div class="message_svg_icon">
				<svg height="14px" stroke-width="14px">
					<path fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M6.075,14.407l-5.852-5.84l1.616-1.613l4.394,4.385L17.181,0.411l1.616,1.613L6.392,14.407H6.075z"></path>
				</svg>
			</div>
		</div>
	</div>

	<div id="error_message" class="arf_error_message">
		<div class="message_descripiton">
			<div id="error_msg_text"></div>
			<div class="message_svg_icon">
				<svg height="14px" stroke-width="14px">
					<path fill-rule="evenodd" clip-rule="evenodd" fill="#ffffff" d="M10.702,10.909L6.453,6.66l-4.249,4.249L1.143,9.848l4.249-4.249L1.154,1.361l1.062-1.061l4.237,4.237l4.238-4.237l1.061,1.061L7.513,5.599l4.249,4.249L10.702,10.909z"></path>
				</svg>
			</div>
		</div>
	</div>



	<div class="top_bar">
		<span class="h2"><?php esc_html_e( 'Post Creator Configuration', 'ARForms-postcreator' ); ?></span>
	</div>
	<div id="poststuff" class="metabox-holder">
		<div id="post-body">
			<div class="inside">
				<div class="frm_settings_form wrap_content ">
					<?php
					if ( $arfaction == '' ) {
						$arfaction = $_REQUEST['arfaction'];
					}

					if ( isset( $values['form_id'] ) and $values['form_id'] != '' ) {
						$form_name           = $field_array[0];
						$values['form_name'] = $form_name->form_name;
					}

					$nonce_field = wp_create_nonce( 'arf_postcreator' );
					?>
					
					<input type="hidden" id="arfpostcreator_nonce" value="<?php echo esc_html( $nonce_field ); ?>" />
					<input type="hidden" id="ajaxurl" value="<?php echo admin_url( 'admin-ajax.php' ); ?>" />

					<form name="arf_postcreator_setting" id="arf_postcreator_setting" method="post" onSubmit="return arf_postcreator_save();" enctype="multipart/form-data">
						<input type="hidden" id="arfaction" name="arfaction" value="<?php echo esc_html( $arfaction ); ?>">
						<input type="hidden" name="form_id" id="form_id" value="<?php echo esc_html( $values['form_id'] ); ?>">
						<input type="hidden" name="id" id="id" value="<?php echo esc_html( $values['id'] ); ?>">
						<input type="hidden" name="form_name" id="form_name" value="<?php echo esc_html( $values['form_name'] ); ?>">
						<div class="ul_li_list arf_pc_display_none">
							<ul class="all_fields" id="all_fields_ul">
							</ul>
							<ul class="all_post" id="all_post_ul">
							<?php
							global $wpdb;
							$sql  = 'SELECT meta_key FROM ' . $wpdb->postmeta . ' pm LEFT JOIN ' . $wpdb->prefix . 'posts p ON pm.post_id=p.ID GROUP BY pm.meta_key HAVING pm.meta_key NOT LIKE %s ORDER BY pm.meta_key';
							$keys = $wpdb->get_col( $wpdb->prepare( $sql, '\_%' ) );
							
							foreach ( $keys as $key => $value ) {
								echo "<li class='arf_selectbox_option' data-value=" . $key . ' data-label=' . $key . '>' . $key . '</li>';
							}
							?>
							</ul>
						</div>
						<div class="field_gray arf_pc_float_width">
							<table class="form-table arf_pc_float_left">
								<tr class="tdclass">
									<td width="18%" class="tdclass" valign="top">
										<label class="lblsubtitle"><?php esc_html_e( 'Select Post Type', 'ARForms-postcreator' ); ?>&nbsp;&nbsp;<span class="arfglobalrequiredfield arf_pc_valign_top">*</span></label>
									</td>
									<td class='arf_pc_table_data'>
										<div class="arf_radio_wrapper">
											<div class="arf_custom_radio_wrapper">
												<input type="radio" class="arf_custom_radio" name="arf_postcreator_post_type" id="arf_post_type_basic" onchange="javascript:is_checked(this.id, this.checked);" value="basic" <?php checked( $values['post_type'], 'basic' ); ?> />
												<svg width="18px" height="18px">
													<?php echo ARF_CUSTOM_UNCHECKEDRADIO_ICON; ?>
													<?php echo ARF_CUSTOM_CHECKEDRADIO_ICON; ?>
												</svg>
											</div>

											<span>
												<label for="arf_post_type_basic"><?php esc_html_e( 'Basic Post', 'ARForms-postcreator' ); ?></label>
											</span>
										</div>
										<div class="arf_radio_wrapper">
											<div class="arf_custom_radio_wrapper">
												<input type="radio" class="arf_custom_radio " name="arf_postcreator_post_type" id="arf_post_type_custom" onchange="javascript:is_checked(this.id, this.checked);" value="custom" <?php checked( $values['post_type'], 'custom' ); ?>  />
												<svg width="18px" height="18px">
													<?php echo ARF_CUSTOM_UNCHECKEDRADIO_ICON; ?>
													<?php echo ARF_CUSTOM_CHECKEDRADIO_ICON; ?>
												</svg>
											</div>

											<span>
												<label for="arf_post_type_custom"><?php esc_html_e( 'Custom', 'ARForms-postcreator' ); ?></label>
											</span>
										</div>
					
										 <div class="arf_radio_wrapper">
											<div class="arf_custom_radio_wrapper">
						
												<input type="radio" class="arf_custom_radio " name="arf_postcreator_post_type" id="arf_post_type_page" onchange="javascript:is_checked(this.id, this.checked);" value="page" <?php checked( $values['post_type'], 'page' ); ?>  />
												<svg width="18px" height="18px">
												<?php echo ARF_CUSTOM_UNCHECKEDRADIO_ICON; ?>
												<?php echo ARF_CUSTOM_CHECKEDRADIO_ICON; ?>
												</svg>
											</div>

											<span>
												<label for="arf_post_type_page"><?php esc_html_e( 'Page', 'ARForms-postcreator' ); ?></label>
											</span>
										</div>

										<?php 
										if ($arf_postcreator->is_buddypress_active() && bp_is_active('groups')) {
										?>
											<div class="arf_radio_wrapper">
												<div class="arf_custom_radio_wrapper">
													<input type="radio" class="arf_custom_radio " name="arf_postcreator_post_type" id="arf_post_type_buddypress_grp" onchange="javascript:is_checked(this.id, this.checked);" value="buddypress_grp" <?php checked( $values['post_type'], 'buddypress_grp' ); ?>  />
													<svg width="18px" height="18px">
														<?php echo ARF_CUSTOM_UNCHECKEDRADIO_ICON; ?>
														<?php echo ARF_CUSTOM_CHECKEDRADIO_ICON; ?>
													</svg>
												</div>

												<span>
													<label for="arf_post_type_buddypress_grp"><?php esc_html_e( 'BuddyPress Group', 'ARForms-postcreator' ); ?></label>
												</span>
											</div>
										<?php } ?>
									</td>
								</tr>
								<tr class="tdclass arf_pc_display_none" id="custom_post_type_list">
									<td width="18%" class="tdclass" valign="top">
										<label class="lblsubtitle"><?php esc_html_e( 'Custom Post type', 'ARForms-postcreator' ); ?>&nbsp;&nbsp;<span class="arfglobalrequiredfield arf_pc_valign_top">*</span></label>
									</td>
									<td>
										<div class="arf_form_dropdown arf_postcreator_custom_post">
											<div class="sltstandard">
												<?php echo ARF_PostCreator::field_custom_post( $values['form_id'], 'arf_postcreator_custom_post', 'frm-dropdown arf_postcreator_custom_post ', $values['custom_post'], 'arf_postcreator_custom_post' ); ?>
											</div>
										</div>
										<div class="arferrmessage" id="arf_postcreator_custom_post_msg"><?php esc_html_e( 'This field cannot be blank.', 'ARForms-postcreator' ); ?></div>
									</td>
								</tr>

								<tr class="tdclass">
									<td width="18%" class="tdclass" valign="top">
										<label class="lblsubtitle"><?php esc_html_e( 'Select Form', 'ARForms-postcreator' ); ?>&nbsp;&nbsp;<span class="arfglobalrequiredfield arf_pc_valign_top">*</span></label>
									</td>
									<td>
										<?php
										if ( $arfaction == 'new' ) {
											global $arfform,$armainhelper;

											$exclude_ids = array( '-1' );
											
											if( version_compare( $arf_version, '4.3', '<' ) ){

												$form_data   = $wpdb->get_results( 'SELECT * FROM ' . $wpdb->prefix . 'arf_postcreator_forms' );

											}else{

												$form_data = $arfform->arf_select_db_data(true, '', $wpdb->prefix . 'arf_postcreator_forms', '*');

											}


											if ( count( $form_data ) > 0 ) {
												foreach ( $form_data as $form_new ) {
													$exclude_ids[] = $form_new->form_id;
												}
											}

											$where          = "is_template=0 AND (status is NULL OR status = '' OR status = 'published') AND id not in (" . implode( ',', $exclude_ids ) . ')';
											$return_results = array();
											$return_results = apply_filters( 'arf_addon_getallforms', $return_results, $where, ' ORDER BY name' );

											$selected_list_id      = '';
											$selected_list_label   = esc_html__( 'Please select form', 'ARForms-postcreator' );
											$responder_list_option = '<li class="arf_selectbox_option" data-value="" data-label="' . $selected_list_label . '">' . $selected_list_label . '</li>';
											$responder_list_option_arr = array(
							                                '' => addslashes(esc_html__("Please select form", "ARForms-postcreator"))
							                            );

											$cntr = 0;
											foreach ( $return_results as $form ) {
												$responder_list_option .= '<li class="arf_selectbox_option" data-value="' . $form['id'] . '" data-label="' . $form['name_width_id'] . '">' . $armainhelper->truncate( $form['name_width_id'], 33 ) . '</li>';
												$responder_list_option_arr[$form['id']] = $form['name_width_id'];
												$cntr++;
											}

											?>

											<div class="arf_form_dropdown arf_postcreator_form">
												<div class="sltstandard arf_postcreator_div_height">
													<?php if( method_exists( $maincontroller, 'arf_selectpicker_dom') ){
														/*echo $maincontroller->arf_selectpicker_dom( 'arf_postcreator_form', 'arf_postcreator_form', '', 'width:400px;', '', array(), $responder_list_option_arr );*/
														$select_attrs = array(
															'onChange'	=>	'arf_postcreator_form_change()',
															'class'		=>	isset( $class ) ? $class : ''
														);

														echo $maincontroller->arf_selectpicker_dom( 'arf_postcreator_form', 'arf_postcreator_form', ' arf_pc_form_list', '',  $selected_list_id , $select_attrs , $responder_list_option_arr, false, array(), false, array(), false, array(), true );
                            							} else { ?>
													<input id="arf_postcreator_form"  name="arf_postcreator_form" value="<?php echo esc_html( $selected_list_id ); ?>" type="hidden" class="<?php echo isset( $class ) ? $class : ''; ?>" onChange="arf_postcreator_form_change();">
														<dl class="arf_selectbox arf_pc_form_list" data-name="arf_postcreator_form" data-id="arf_postcreator_form">
															<dt><span><?php echo $selected_list_label; ?></span>
															<input value="<?php echo esc_html( $selected_list_id ); ?>" class="arf_autocomplete" type="text" autocomplete="off">
															<svg viewBox="0 0 2000 1000" width="15px" height="15px">
															<g fill="#000">
															<path d="M1024 320q0 -26 -19 -45t-45 -19h-896q-26 0 -45 19t-19 45t19 45l448 448q19 19 45 19t45 -19l448 -448q19 -19 19 -45z"></path>
															</g>
															</svg>
															</dt>
															<dd>
																<ul data-id="arf_postcreator_form">
																		<?php echo $responder_list_option; ?>
																</ul>
															</dd>
														</dl>
													<?php } ?>
												</div>
											</div>
											<div class="arferrmessage" id="arf_postcreator_form_msg"><?php esc_html_e( 'This field cannot be blank.', 'ARForms-postcreator' ); ?></div>
										<?php } else { ?>
											<label class="lblsubtitle"><strong><?php echo $values['form_name']; ?></strong></label>
										<?php } ?>
									</td>
								</tr>

							</table>
						</div>

						<div class="rounded_corner field_gray">
							<table class="form-table">
								<tr class="tdclass">
									<td valign="top" colspan="2" class="lbltitle titleclass"><?php esc_html_e( 'Basic Fields', 'ARForms-postcreator' ); ?></td>
								</tr>
								<tr class="tdclass arf_pc_allow_comment_wrap">
									<td valign="top" width="18%" class="tdclass">
										<label class="lblsubtitle"><?php esc_html_e( 'Title', 'ARForms-postcreator' ); ?>&nbsp;&nbsp;<span class="arfglobalrequiredfield arf_pc_valign_top">*</span></label>
									</td>
									<td>
										<div class="arf_form_dropdown arf_postcreator_title">
											<div class="sltstandard arf_postcreator_div_height">
												<?php echo ARF_PostCreator::field_dropdown( $values['form_id'], 'arf_postcreator_title', 'frm-dropdown arf_postcreator_title arf_postcreator_fields', $values['title'], '', $field_array ); ?>
											</div>
										</div>
										<div class="arferrmessage" id="arf_postcreator_title_msg" ><?php esc_html_e( 'This field cannot be blank.', 'ARForms-postcreator' ); ?></div>
									</td>
								</tr>
								<tr class="tdclass">
									<td width="18%" valign="top" class="tdclass arf_pc_valign_top"><label class="lblsubtitle"><?php esc_html_e( 'Description', 'ARForms-postcreator' ); ?>&nbsp;&nbsp;<span class="arfglobalrequiredfield arf_pc_valign_top arf_pc_display_none" id="arf_description_req">*</span></label></td>
									<td class="arf_pc_discription_data">
										<div class="arf_form_dropdown arf_postcreator_description">
											<div class="sltstandard">
												<?php echo ARF_PostCreator::field_dropdown( $values['form_id'], 'arf_postcreator_description', 'frm-dropdown arf_postcreator_description arf_postcreator_fields', $values['description'], '', $field_array ); ?>
											</div>
										</div>
										<div class="arferrmessage" id="arf_postcreator_description_msg"><?php esc_html_e( 'This field cannot be blank.', 'ARForms-postcreator' ); ?></div>
									</td>
								</tr>
								<?php
									$is_excerpt_field_visible = '';
								if ( $_REQUEST['arfaction'] == 'edit' && $_REQUEST['id'] != '' && $values['post_type'] == 'page' ) {
									$is_excerpt_field_visible = 'arf_pc_display_none';
								}
								?>
								<tr class="tdclass <?php echo esc_attr( $is_excerpt_field_visible ); ?>" id="arf_postcreator_excerpt_main">
									<td width="18%" valign="top" class="tdclass">
										<label class="lblsubtitle"><?php esc_html_e( 'Excerpt', 'ARForms-postcreator' ); ?></label>
									</td>
									<td>
										<div class="arf_form_dropdown arf_postcreator_excerpt">
											<div class="sltstandard">
												<?php echo ARF_PostCreator::field_dropdown( $values['form_id'], 'arf_postcreator_excerpt', 'frm-dropdown arf_postcreator_excerpt arf_postcreator_fields', ( isset( $values['excerpt'] ) ? $values['excerpt'] : '' ), '', $field_array ); ?>
											</div>
										</div>
										<div class="arferrmessage" id="arf_postcreator_excerpt_msg" ><?php esc_html_e( 'This field cannot be blank.', 'ARForms-postcreator' ); ?></div>
									</td>
								</tr>
								<tr class="tdclass arf_pc_allow_comment_wrap" id="arf_postcreator_status_main">
									<td width="18%" valign="top" class="tdclass">
										<label class="lblsubtitle"><?php esc_html_e( 'Status', 'ARForms-postcreator' ); ?>&nbsp;&nbsp;<span class="arf_pc_valign_top arfglobalrequiredfield">*</span></label>
									</td>
									<td>
										<div class="sltstandard">
											<div class="arf_form_dropdown arf_postcreator_form">
												<div class="sltstandard">
													<?php
													$selected_list_id    = 'publish';
													$selected_list_label = esc_html__( 'Published', 'ARForms-postcreator' );
													if ( $values['status'] == 'publish' ) {
														$selected_list_id    = 'publish';
														$selected_list_label = esc_html__( 'Published', 'ARForms-postcreator' );
													} elseif ( $values['status'] == 'draft' ) {
														$selected_list_id    = 'draft';
														$selected_list_label = esc_html__( 'Draft', 'ARForms-postcreator' );
													} elseif ( $values['status'] == 'pending' ) {
														$selected_list_id    = 'pending';
														$selected_list_label = esc_html__( 'Pending review', 'ARForms-postcreator' );
													} 
													$post_creator_status_li = '';
													$post_creator_status = array(
														'publish' => 'Published',
														'draft' => 'Draft',
														'pending' => 'Pending review',
													);

													if (! empty($post_creator_status) ) {
														foreach ( $post_creator_status as $key => $value ) {

															$post_creator_status_li .= '<li class="arf_selectbox_option" data-value="' . $key . '" data-label="' . $value . '">' . $value . '</li>';
                                    						$post_creator_status_li_arr[$key] = $value;
                                    					}
                                    				}
												
													if( method_exists( $maincontroller, 'arf_selectpicker_dom') ){
														/*echo $maincontroller->arf_selectpicker_dom( 'arf_postcreator_status', 'arf_postcreator_status', '', 'width:400px;', '', array(), $post_creator_status_li_arr );*/
														echo $maincontroller->arf_selectpicker_dom( 'arf_postcreator_status', 'arf_postcreator_status', ' arf_pc_selectfield ', '', $selected_list_id, array(), $post_creator_status_li_arr, false, array(), false, array(), false,  array(), false, ' arf_postcreator_status'  );
                            						} else { ?>
													<input id="arf_postcreator_status"  name="arf_postcreator_status" value="<?php echo esc_html( $selected_list_id ); ?>" type="hidden">
														<dl class="arf_selectbox arf_pc_selectfield" data-name="arf_postcreator_status" data-id="arf_postcreator_status">
															<dt><span><?php echo $selected_list_label; ?></span>
															<svg viewBox="0 0 2000 1000" width="15px" height="15px">
															<g fill="#000">
															<path d="M1024 320q0 -26 -19 -45t-45 -19h-896q-26 0 -45 19t-19 45t19 45l448 448q19 19 45 19t45 -19l448 -448q19 -19 19 -45z"></path>
															</g>
															</svg>
															</dt>
															<dd>
																<ul data-id="arf_postcreator_status" class="arf_postcreator_status">
																	<?php echo $post_creator_status_li; ?>
																</ul>
															</dd>
														</dl>
													<?php } ?>
												</div>
											</div>
										</div>
										<div class="arferrmessage" id="arf_postcreator_status_msg"><?php esc_html_e( 'This field cannot be blank.', 'ARForms-postcreator' ); ?></div>
									</td>
								</tr>
								<tr class="tdclass arf_pc_allow_comment_wrap" id="arf_postcreator_status_main">
									<td width="18%" valign="top" class="tdclass">
										<label class="lblsubtitle"><?php esc_html_e( 'Allow comment', 'ARForms-postcreator' ); ?></label>
									</td>
									<td class="arf_pc_table_data" >
									<label class="arf_js_switch_label">
										<span>&nbsp;<?php esc_html_e( 'No', 'ARForms-postcreator' ); ?></span>
									</label>
									<span class="arf_js_switch_wrapper">
										<input type="checkbox" class="js-switch" name="arf_allow_comment" id="arf_allow_comment" value="1" <?php checked( $values['arf_allow_comment'], '1' ); ?> />
										<span class="arf_js_switch"></span>
									</span>
									<label class="arf_js_switch_label">
										<span>&nbsp;<?php esc_html_e( 'Yes', 'ARForms-postcreator' ); ?></span>
									</label>                                    
								   </td>
								</tr>
							</table>
						</div>
						<div class="rounded_corner field_gray" id="advance_field_section_wrap" >
							<table class="form-table">
								<tbody class="post_advanced_fields" >
									<tr class="tdclass">
										<td valign="top" colspan="2" class="lbltitle titleclass"><?php esc_html_e( 'Advanced Fields', 'ARForms-postcreator' ); ?></td>
									</tr>
									<tr class="post_advanced_featured_image" id="post_advanced_featured_image">
										<td width="18%" valign="top" class="tdclass">
											<label class="lblsubtitle"><?php esc_html_e( 'Featured Image', 'ARForms-postcreator' ); ?></label>
										</td>
										<td>
											<div class="arf_form_dropdown arf_postcreator_featured_img">
												<div class="sltstandard">
													<?php echo ARF_PostCreator::file_field_dropdown( $values['form_id'], 'arf_postcreator_featured_img', 'frm-dropdown arf_postcreator_featured_img arf_postcreator_file_fields', $values['image'], '', $field_array ); ?>
												</div>
											</div>
										</td>
									</tr>
									<?php
										$is_post_tag_visible = '';
									if ( $_REQUEST['arfaction'] == 'edit' && $_REQUEST['id'] != '' && $values['post_type'] == 'page' ) {
										$is_post_tag_visible = ' arf_pc_display_none ';
									}
									?>
									<tr id="arf_postcreator_tags" class="<?php echo esc_attr( $is_post_tag_visible ); ?>">
										<td width="18%" valign="top" class="tdclass">
											<label class="lblsubtitle"><?php esc_html_e( 'Tags', 'ARForms-postcreator' ); ?>&nbsp;&nbsp;<span class="arfglobalrequiredfield arf_pc_valign_top">&nbsp;&nbsp;</span></label>
										</td>
										<td>
											<div class="arf_form_dropdown arf_postcreator_tag">
												<div class="sltstandard">
													<?php echo ARF_PostCreator::field_dropdown( $values['form_id'], 'arf_postcreator_tag', 'frm-dropdown arf_postcreator_tag arf_postcreator_fields', isset( $values['tag'] ) ? $values['tag'] : '', '', $field_array ); ?>
												</div>
											</div>
										</td>
									</tr>
									<tr class="tdclass">
										<td width="18%" valign="top" class="tdclass">
											<label class="lblsubtitle"><?php esc_html_e( 'Author', 'ARForms-postcreator' ); ?>&nbsp;&nbsp;<span class="arfglobalrequiredfield arf_pc_valign_top">*</span></label>
										</td>
										<td>
											<div class="sltstandard">
												<?php
												global $wp_version;
												$args  = array(
													'blog_id' => $GLOBALS['blog_id'],
													'fields' => array(
														'ID',
														'display_name',
													),
												);
												$users = get_users( $args );
												?>
												<div class="arf_form_dropdown arf_postcreator_author">
													<div class="sltstandard">
														<?php
														$autocomplete_author_value = $arf_postcreator_author_lable = '';
														foreach ( $users as $k => $user ) {
															if ( $values['author'] == $user->ID ) {
																$arf_postcreator_author_lable = $user->display_name;
															}
															$autocomplete_author_value .= "<li class=\"arf_selectbox_option\" data-value=\"{$user->ID}\" data-label=\"{$user->display_name}\">{$user->display_name}</li>";
															$autocomplete_author_value_arr[$user->ID] = $user->display_name;
														}
														if( method_exists( $maincontroller, 'arf_selectpicker_dom') ){
															/*echo $maincontroller->arf_selectpicker_dom( 'arf_postcreator_author_value', 'arf_postcreator_author_value', '', 'width:400px;', '', array(), $autocomplete_author_value_arr );*/
															echo $maincontroller->arf_selectpicker_dom( 'arf_postcreator_author_value', 'arf_postcreator_author_value', ' arf_pc_selectfield ', '', $values['author'], array(), $autocomplete_author_value_arr, false, array(), false, array(), false,  array(), false, 'arf_postcreator_author' );
                            							} else {
														?>
														<input id="arf_postcreator_author_value" type="hidden" name="arf_postcreator_author_value" value="<?php echo esc_html( $values['author'] ); ?>" />

															<dl class="arf_selectbox arf_pc_selectfield" data-name="arf_postcreator_author_value" data-id="arf_postcreator_author_value">
																<dt><span><?php echo $arf_postcreator_author_lable; ?></span>
																<svg viewBox="0 0 2000 1000" width="15px" height="15px">
																<g fill="#000">
																<path d="M1024 320q0 -26 -19 -45t-45 -19h-896q-26 0 -45 19t-19 45t19 45l448 448q19 19 45 19t45 -19l448 -448q19 -19 19 -45z"></path>
																</g>
																</svg>
																</dt>
																<dd>
																	<ul data-id="arf_postcreator_author_value" class="arf_postcreator_author">
																		<?php echo $autocomplete_author_value; ?>
																	</ul>
																</dd>
															</dl>
														<?php } ?>
													</div>
												</div>
												<div class="arfpost_orclass">
													<?php esc_html_e( 'OR', 'ARForms-postcreator' ); ?>
												</div>
												<label class="arf_js_switch_label">
													<span></span>
												</label>
												<span class="arf_js_switch_wrapper">
													<input type="checkbox" class="js-switch" id="arf_postcreator_author" onchange="is_default_author();" name="arf_postcreator_author" value="default" <?php checked( $values['author'], 'default' ); ?> />
													<span class="arf_js_switch"></span>
												</span>
												<label class="arf_js_switch_label" for="arf_postcreator_author">
													<span>&nbsp;<?php esc_html_e( 'Automatically assign logged in user', 'ARForms-postcreator' ); ?></span>
												</label>                                                
											</div>
											<div class="arferrmessage" id="arf_postcreator_author_msg" ><?php esc_html_e( 'This field cannot be blank.', 'ARForms-postcreator' ); ?></div></td>
									</tr>
									<tr class="tdclass">
										<td>&nbsp;</td>
									</tr>
									<tr class="tdclass"><td width="18%" valign="top" class="tdclass"><label class="lblsubtitle"><?php esc_html_e( 'Created Date', 'ARForms-postcreator' ); ?>&nbsp;&nbsp;<span class="arfglobalrequiredfield arf_pc_valign_top">*</span></label></td><td>
											<div class="sltstandard">
												<div class="arf_form_dropdown arf_postcreator_date">
													<div class="sltstandard">
														<?php echo ARF_PostCreator::field_dropdown( $values['form_id'], 'arf_postcreator_date', 'frm-dropdown arf_postcreator_date arf_postcreator_fields', $values['date'], 'arf_postcreator_date_list', $field_array ); ?>
													</div>
												</div>
												<div class="arfpost_orclass">
													<?php esc_html_e( 'OR', 'ARForms-postcreator' ); ?>
												</div>
												<label class="arf_js_switch_label">
													<span></span>
												</label>
												<span class="arf_js_switch_wrapper">
													<input type="checkbox" class="js-switch" id="arf_postcreator_date" onchange="is_default_date();" name="arf_postcreator_date" value="default" <?php checked( $values['date'], 'default' ); ?> />
													<span class="arf_js_switch"></span>
												</span>
												<label class="arf_js_switch_label" for="arf_postcreator_date">
													<span>&nbsp;<?php esc_html_e( 'Set current date while posting data', 'ARForms-postcreator' ); ?></span>
												</label>                                                
											</div>
											<div class="arferrmessage" id="arf_postcreator_date_msg" ><?php esc_html_e( 'This field cannot be blank.', 'ARForms-postcreator' ); ?></div></td>
									</tr>
								</tbody>
							</table>
						</div>

						<!-- start buddy press setting section  -->
						<?php
							$remove_border_bp = '';
							if ( 'buddypress_grp' == $values['post_type'] ) {
								$remove_border_bp = 'style="border-bottom: none;"';
							}
						?>
						<div class="rounded_corner field_gray" <?php echo $remove_border_bp; ?> >
							<table class="form-table" id="arf_pc_bp_settings">
								<tbody class="post_bp_group_fields" >
									<tr class="tdclass">
										<td valign="top" colspan="2" class="lbltitle titleclass"><?php esc_html_e( 'BuddyPress Settings', 'ARForms-postcreator' ); ?></td>
									</tr>
									
									<tr>
										<td width="18%" valign="top" class="tdclass" colspan="2">
											<div class="arf_post_group_dd_wrapper">
												<label class="lblsubtitle"><?php esc_html_e( 'Let user can select Group', 'ARForms-postcreator' ); ?>&nbsp;&nbsp;<span class="arfglobalrequiredfield arf_pc_valign_top">&nbsp;&nbsp;</span></label>
												<div id="arf_postcreator_user_filled_group_main">
													<div class="">

														<div class="sltstandard" id="sltstandard">
															<?php 
															$select_grp_nm = isset($values['bp_group_name']) ? $values['bp_group_name'] : '';
															echo ARF_PostCreator::field_dropdown( $values['form_id'], 'arf_postcreator_bp_group', 'frm-dropdown arf_postcreator_bp_group arf_postcreator_fields', $select_grp_nm, 'arf_postcreator_bp_group_list', $field_array ); ?>

															<!-- ( $form_id, $name = '', $class = '', $default_value = '', $id = '', $field_array ) -->
														</div>
														<label class="arf_pc_from_category_label"> <?php echo sprintf( esc_html__( 'From %s Group %s', 'ARForms-postcreator' ), '<b>', '</b>' ); ?> </label>
													</div>


													<div class="arf_pc_from_category_separator">
														<label class="arfpost_orclass"><?php echo esc_html__( 'OR', 'ARForms-postcreator' ); ?></label>
													</div>


													<label class="lblsubtitle arf_pc_cc_select_label">
														<?php esc_html_e( 'Select Group Manually', 'ARForms-postcreator' ); ?>&nbsp;&nbsp;<span class="arfglobalrequiredfield arf_pc_valign_middle">&nbsp;&nbsp;</span>
													</label>
													<div class="arf_form_dropdown arf_postcreator_custom_post">
														<div class="sltstandard">
															<?php 
																$select_grp_nm = isset($values['bp_group_name_array']) ? $values['bp_group_name_array'] : '';
																echo ARF_PostCreator::get_buddypress_group_list( $values['form_id'], 'arf_postcreator_buddypress_grp', 'frm-dropdown arf_postcreator_buddypress_grp ', $select_grp_nm, 'arf_postcreator_buddypress_grp' );
															?>
														</div>
													</div>
													
													<div class="arferrmessage" id="arf_postcreator_bp_grp_msg"><?php esc_html_e( 'Please Select at least one Group.', 'ARForms-postcreator' ); ?></div>
												</div>
											</div>

										</td>
									</tr>
								</tbody>
							</table>
						</div>

						<!-- end of buddypress setting section -->

						<div class="rounded_corner field_gray" >
							<table class="form-table" id="arf_postcreator_format">
								<tbody class="post_format_fields" >
									<tr class="tdclass">
										<td valign="top" colspan="2" class="lbltitle titleclass"><?php esc_html_e( 'Post Format', 'ARForms-postcreator' ); ?></td>
									</tr>
									<tr>
										<td width="18%" valign="top" class="tdclass" colspan="2">
											<div class="arf_post_format_dd_wrapper">
												<label class="lblsubtitle"><?php esc_html_e( 'Let user can select Format', 'ARForms-postcreator' ); ?>&nbsp;&nbsp;<span class="arfglobalrequiredfield arf_pc_valign_top">&nbsp;&nbsp;</span></label>
												<div id="arf_postcreator_user_filled_formats_main">
													<?php
													global $arf_postcreator;
													$arf_postcreator->arf_postcreator_post_format_list( $values['form_id'], 'arf_post_format', 'frm-dropdown arf_postcreator_user_filled_fields', ( isset( $values['post_format'] ) ? $values['post_format'] : '' ), 'arf_postcreator_user_filled_formats', ( isset( $values['post_format_fixed'] ) ? $values['post_format_fixed'] : '' ), $field_array );

													?>
												</div>
											</div>
										</td>
									</tr>
								</tbody>
							</table>
						</div>

						<div class="rounded_corner field_gray">
							<table class="form-table" id="arf_postcreator_category">
								<?php echo $arf_postcreator->categories( $values ); ?>
							</table>
						</div>
						<?php
							$hide_section_bp = '';
							if ( 'buddypress_grp' == $values['post_type'] ) {
								$hide_section_bp = 'style="display: none;"';
							}
							do_action('arf_postcreator_settings_block_outside', $values);
						?>
						<div class="rounded_corner field_gray arf_pc_cf_wrapper">
							<table class="form-table arf_post_custom_fields" id="arf_postcreator_category" <?php echo $hide_section_bp; ?> >
							<tbody>
								<tr class="tdclass">
									<td valign="top" colspan="2" class="lbltitle arf_pc_cf_label"><?php esc_html_e( 'Post Custom Fields', 'ARForms-postcreator' ); ?></td>
								</tr>
								<tr class="tdclass arfmaintdclass">
									<td valign="top" class="tdclass arfpost_field_data" colspan="2">
										<div class="arfbutton_class">
											<button type="button" class="add_blank_meta" onclick="
											<?php
											if ( $arfaction == 'edit' ) {
												?>
												edit_post_meta_row(1);
												<?php
											} else {
												?>
												add_post_meta_row(1);<?php } ?>"><?php esc_html_e( 'Map existing data from fields', 'ARForms-postcreator' ); ?></button>
										</div>
										<div class="arfbutton_class">
											<button type="button" class="add_blank_meta" onclick="
											<?php
											if ( $arfaction == 'edit' ) {
												?>
												edit_post_meta_row(0);
												<?php
											} else {
												?>
												add_post_meta_row(0);<?php } ?>"><?php esc_html_e( 'Add Blank Meta', 'ARForms-postcreator' ); ?></button>
										</div>
										<div class="arfbutton_class">
											<button type="button" class="add_blank_meta" onclick="
											<?php
											if ( $arfaction == 'edit' ) {
												?>
												edit_post_meta_row(2);
												<?php
											} else {
												?>
												add_post_meta_row(2);<?php } ?>"><?php esc_html_e( 'Add Blank Field', 'ARForms-postcreator' ); ?></button>
										</div>
										<div class="arfbutton_class">
											<button type="button" class="add_blank_meta" onclick="
											<?php
											if ( $arfaction == 'edit' ) {
												?>
												edit_post_meta_row(3);
												<?php
											} else {
												?>
												add_post_meta_row(3);<?php } ?>"><?php esc_html_e( 'Add Blank Meta & Field', 'ARForms-postcreator' ); ?></button>
										</div>
									</td>
									<td valign="top" class="tdclass arf_pc_text_left" colspan="2">
										<div id="arf_custom_fields" class="arf_pc_clear_both">
											<?php
											$total_field = 0;
											$field_name  = isset( $values['custom_fields'] ) ? $values['custom_fields'] : '';
											$field_value = isset( $values['custom_field_value'] ) ? $values['custom_field_value'] : '';
											$total_field = is_array( $field_value ) ? count( $field_value ) : 0;

											if ( $arfaction == 'new' ) {
												?>
												<div id="custom_fields" class="sltstandard arf_pc_clear_both">
													<?php echo ARF_PostCreator::custom_fields( $values, 'custom_field_name', 'custom_field_value', $total_field, $arfaction, $field_array ); ?>
												</div>
												<input type="hidden" name="total_custom_fields" id="total_custom_fields" value="<?php echo esc_html( $total_field ); ?>" />
												<input type="hidden" name="last_custom_field_no" id="last_custom_field_no" value="<?php echo esc_html( $total_field ); ?>" />
											<?php } if ( $arfaction == 'edit' ) { ?>
												<div id="custom_fields_edit_mode" class="sltstandard arf_pc_clear_both">
													<?php echo ARF_PostCreator::custom_fields( $values, 'custom_field_name', 'custom_field_value', $total_field, $arfaction, $field_array ); ?>
												</div>
												<input type="hidden" name="total_custom_fields" id="total_custom_fields" value="<?php echo esc_html( $total_field ); ?>" />
												<input type="hidden" name="last_custom_field_no" id="last_custom_field_no" value="<?php echo esc_html( $total_field ); ?>" />
											<?php } ?>
										</div>
										<?php if ( $total_field == 0 ) { ?>
											<div class="arf_postcreator_blank_field_msg"><?php esc_html_e( 'No Field added', 'ARForms-postcreator' ); ?></div>
										<?php } ?>

										<div class="arferrmessage" id="arf_postcreator_custom_field_msg"><?php esc_html_e( 'Please Select Form.', 'ARForms-postcreator' ); ?></div>
									</td>
								</tr>
							</tbody>
						</table>
						</div>
						<div class="arf_pc_submit_btn_wrapper">
							<button class="rounded_button arf_btn_dark_blue" id="save_arf_postcreator" name="save_arf_postcreator" type="submit"><?php esc_html_e( 'Save', 'ARForms-postcreator' ); ?></button>
							&nbsp;&nbsp;
							<button class="rounded_button arf_btn_cancel" type="button" onclick="location.href = '?page=ARForms-postcreator'"><?php esc_html_e( 'Cancel', 'ARForms-postcreator' ); ?></button>
							<input type="hidden" name="feature_img" id="feature_img"  />
							<div class="arf_pc_save_loader"></div>
						</div>
					</form>
				</div>
			</div>
		</div>
	</div>
</div>