"use strict";

function arf_ChangeID(id) {
	document.getElementById( 'delete_entry_id' ).value = id;
	arfchangedeletemodalwidth( 'arfdeletemodabox' );
}

function arfpostcreatorformactionfunc(act, id) {
	if (act == 'delete') {
		id = document.getElementById( 'delete_entry_id' ).value;
	}
	jQuery.ajax(
		{
			type: "POST",
			url: ajaxurl,
			data: "action=arf_postcreator_delete_form&act=" + act + "&id=" + id,
			dataType:'json',
			beforeSend: function() {
				jQuery( ".arf_loader_icon_wrapper" ).show();
			},
			success: function(msg) {
				jQuery( ".arf_loader_icon_wrapper" ).hide();

				if (  0 < msg.errors.length) {
					jQuery( '#error_msg_text' ).html( msg.errors[0] );
					error_msg();
				} else {
					jQuery( '#success_msg_text' ).html( msg.message );
					success_msg();
				}
				var post_creator_table = jQuery( ".arf_postcreator_list_form #example" ).DataTable();

				if( __ARF_DB_VERSION > 5.0 ){

					if( __ARF_DB_VERSION < 4.2 ){
						post_creator_table.fnClearTable();
						post_creator_table.fnDestroy();
					} else {
						post_creator_table.clear();
						post_creator_table.destroy();
					}

					var dt_obj = {
						"sDom": '<"H"lfr>t<"footer"ip>',
						"sPaginationType": "four_button",
						"bJQueryUI": true,
						"bPaginate": true,
						"bAutoWidth": false,
						"aoColumnDefs": [{
							"bVisible": false,
							"aTargets": []
						}, {
							"bSortable": false,
							"aTargets": [0, 5]
						}],
						"ordering": true,
						"order":[[1,'desc']],
						"oColVis": {
							"aiExclude": [0, 5]
						},
					}

					if( __ARF_DB_VERSION > 4.1 ){
						dt_obj.language = {
							"searchPlaceholder":__ARF_SEARCH_PLACEHOLDER,
							"search":""
						}
					}

					dt_obj.bProcessing = true;
					dt_obj.bServerSide = true;
					dt_obj.sAjaxSource = ajaxurl;
					dt_obj.sServerMethod = "POST";
					dt_obj.fnServerParams = function (aoData) {
					    aoData.push(
					    	{'name': 'action', 'value': 'arf_retrieve_postcreator_config_data'},
					    );
					};
					dt_obj.fnPreDrawCallback = function () {
					    jQuery("#arf_full_width_loader").show();
					};
					dt_obj.fnDrawCallback = function (oSettings) {
					    jQuery("#arf_full_width_loader").hide();
					    jQuery('.arfhelptip').tipso('destroy');
					    jQuery('.arfhelptip').tipso({
					        position: 'top',
					        maxWidth: '400',
					        useTitle: true,
					        background: '#444444',
					        color: '#ffffff',
					        width: 'auto'
					    });
					};
					dt_obj.aoColumnDefs = [
					    {"bSortable": false, "aTargets": [0]},
					    {"sClass": "center","aTargets":[0]}, 
					    {"sClass": "sorting_1","aTargets":[1]}, 
					    {"sClass": "form_name","aTargets":[2]}, 
					    {"sClass": "form_entries center","aTargets":[3]},
					    {"sClass": "arf_action_cell","aTargets":[6]} 
					];

					jQuery( '.arf_postcreator_list_form #example' ).dataTable(dt_obj);

				}else{

					post_creator_table.clear();
					post_creator_table.destroy();

					var dt_obj = {
						"oLanguage": {
							"sProcessing": "",
							"sEmptyTable": jQuery( '#list_order_msg_for_blank_table' ).val(),
							"sZeroRecords": jQuery( '#list_order_msg_for_blank_table' ).val()
						},
						"sDom": '<"H"lfr>t<"footer"ip>',
						"sPaginationType": "four_button",
						"bJQueryUI": true,
						"bPaginate": true,
						"bAutoWidth": false,
						"aoColumnDefs": [{
							"bVisible": false,
							"aTargets": []
						}, {
							"sClass": "arf_action_cell",
							"aTargets": [6]
						}, {
							"bSortable": false,
							"aTargets": [0, 6]
						}],
						"ordering": true,
	        			"order":[[1,'desc']],
						"oColVis": {
							"aiExclude": [0, 6]
						},
					};
					if( __ARF_DB_VERSION > 4.1 ){
						dt_obj.language = {
							"searchPlaceholder":__ARF_SEARCH_PLACEHOLDER,
			                "search":"",
						};
					}
					var post_creator_table_new = jQuery( '.arf_postcreator_list_form #example' ).dataTable(dt_obj);
					if( msg.gridData.length > 0 ){
						post_creator_table_new.fnAddData( msg.gridData );
					}
				}

				if (jQuery.isFunction( jQuery().tipso )) {
					setTimeout(
						function() {
							jQuery( '#arf_postcreator_forms .arfhelptip' ).tipso(
								{
									position: 'top',
									maxWidth: '400',
									useTitle: true,
									background: '#444444',
									color: '#ffffff',
									width: 'auto'
								}
							);
						},
						10
					)
				}
			},
			error:function(){
				jQuery( ".arf_loader_icon_wrapper" ).hide();
			}
		}
	);
	if (act == 'delete') {
		jQuery( '[data-dismiss="arfmodal"]' ).trigger( "click" );
	}
	return false;
}

function arf_postcreator_form_bulk_act() {
	var str = jQuery( '#arf_postcreator_forms' ).serialize();	
	var action1 = jQuery("#arf_bulk_action_one").val();
    var action2 = jQuery("#arf_bulk_action_two").val();
    var chk_count = jQuery("input[name='item-action[]']:checked").length;
    var final_action = ( action1 != '-1' && action1 != '' ) ? action1 : action2;
     if (final_action == '' || final_action == '-1' || final_action == '-2') {
        jQuery("#error_msg_text").html(__ARF_NO_FILES_SELECT);
        error_msg();
        return false;
    } else if (final_action == 'bulk_delete') {
        if( chk_count == 0 ){
        	jQuery("#error_msg_text").html(__ARF_SELECT_ONE_FILE);
            error_msg();
            return false;
        } else {
            jQuery("#delete_bulk_postcreator_form_message").addClass('arfactive');
            jQuery("#delete_bulk_postcreator_form_message").parent('.arf_modal_overlay').addClass('arfactive');
        }
    }else{

			jQuery.ajax(
				{
					type: "POST",
					url: ajaxurl,
					dataType: 'json',
					data: "action=arf_postcreator_form_bulk_act&" + str,
					beforeSend: function() {
						jQuery( ".arf_loader_icon_wrapper" ).show();
					},
					success: function(msg) {
						jQuery( ".arf_loader_icon_wrapper" ).hide();
						if ( msg.errors.length > 0 ) {
							jQuery( '#error_msg_text' ).html( msg.errors[0] );
							error_msg();
						} else {
							jQuery( '#success_msg_text' ).html( msg.message );
							success_msg();
						}
						var post_creator_table = jQuery( ".arf_postcreator_list_form #example" ).DataTable();

						if( __ARF_DB_VERSION > 5.0 ){

							if( __ARF_DB_VERSION < 4.2 ){
								post_creator_table.fnClearTable();
								post_creator_table.fnDestroy();
							} else {
								post_creator_table.clear();
								post_creator_table.destroy();
							}

							var dt_obj = {
								"sDom": '<"H"lfr>t<"footer"ip>',
								"sPaginationType": "four_button",
								"bJQueryUI": true,
								"bPaginate": true,
								"bAutoWidth": false,
								"aoColumnDefs": [{
									"bVisible": false,
									"aTargets": []
								}, {
									"bSortable": false,
									"aTargets": [0, 5]
								}],
								"ordering": true,
								"order":[[1,'desc']],
								"oColVis": {
									"aiExclude": [0, 5]
								},
							}

							if( __ARF_DB_VERSION > 4.1 ){
								dt_obj.language = {
									"searchPlaceholder":__ARF_SEARCH_PLACEHOLDER,
									"search":""
								}
							}

							dt_obj.bProcessing = true;
							dt_obj.bServerSide = true;
							dt_obj.sAjaxSource = ajaxurl;
							dt_obj.sServerMethod = "POST";
							dt_obj.fnServerParams = function (aoData) {
							    aoData.push(
							    	{'name': 'action', 'value': 'arf_retrieve_postcreator_config_data'},
							    );
							};
							dt_obj.fnPreDrawCallback = function () {
							    jQuery("#arf_full_width_loader").show();
							};
							dt_obj.fnDrawCallback = function (oSettings) {
							    jQuery("#arf_full_width_loader").hide();
							    jQuery('.arfhelptip').tipso('destroy');
							    jQuery('.arfhelptip').tipso({
							        position: 'top',
							        maxWidth: '400',
							        useTitle: true,
							        background: '#444444',
							        color: '#ffffff',
							        width: 'auto'
							    });
							};
							dt_obj.aoColumnDefs = [
							    {"bSortable": false, "aTargets": [0]},
							    {"sClass": "center","aTargets":[0]}, 
							    {"sClass": "sorting_1","aTargets":[1]}, 
							    {"sClass": "form_name","aTargets":[2]}, 
							    {"sClass": "form_entries center","aTargets":[3]},
							    {"sClass": "arf_action_cell","aTargets":[6]} 
							];

							jQuery( '.arf_postcreator_list_form #example' ).dataTable(dt_obj);

						}else{

							post_creator_table.clear();
							post_creator_table.destroy();

							var dt_obj = {
								"oLanguage": {
									"sProcessing": "",
									"sEmptyTable": jQuery( '#list_order_msg_for_blank_table' ).val(),
									"sZeroRecords": jQuery( '#list_order_msg_for_blank_table' ).val()
								},
								"sDom": '<"H"lfr>t<"footer"ip>',
								"sPaginationType": "four_button",
								"bJQueryUI": true,
								"bPaginate": true,
								"bAutoWidth": false,
								"aoColumnDefs": [{
									"bVisible": false,
									"aTargets": []
								}, {
									"sClass": "arf_action_cell",
									"aTargets": [6]
								}, {
									"bSortable": false,
									"aTargets": [0, 6]
								}],
								"ordering": true,
			        			"order":[[1,'desc']],
								"oColVis": {
									"aiExclude": [0, 6]
								},
							};
							if( __ARF_DB_VERSION > 4.1 ){
								dt_obj.language = {
									"searchPlaceholder":__ARF_SEARCH_PLACEHOLDER,
					                "search":"",
								};
							}
							var post_creator_table_new = jQuery( '.arf_postcreator_list_form #example' ).dataTable(dt_obj);
							if( msg.gridData.length > 0 ){
								post_creator_table_new.fnAddData( msg.gridData );
							}

						}

						if (jQuery.isFunction( jQuery().tipso )) {
							setTimeout(
								function() {
									jQuery( '#arf_postcreator_forms .arfhelptip' ).tipso(
										{
											position: 'top',
											maxWidth: '400',
											useTitle: true,
											background: '#444444',
											color: '#ffffff',
											width: 'auto'
										}
									);
								},
								10
							)
						}
					},
					error:function(){
						jQuery( ".arf_loader_icon_wrapper" ).hide();
					}
				}
			);
	}
	return false;
}

function arf_postcreator_save() {
	var req = 0;
	if (jQuery( '#arf_postcreator_form' ).val() == '' && (jQuery( '#arfaction' ).val() == 'new' || jQuery( "#arfaction" ).val() == 'edit')) {
		jQuery( '.arf_postcreator_form .arfbtn.dropdown-toggle' ).css( 'border-color', '#FF0000' );
		jQuery( '.arf_postcreator_form .arfdropdown-menu.open' ).css( 'border-color', '#FF0000' );
		jQuery( '#arf_postcreator_form_msg' ).css( 'display', 'block' );
		req++;
	} else {
		jQuery( '.arf_postcreator_form .arfbtn.dropdown-toggle' ).css( 'border-color', '' );
		jQuery( '.arf_postcreator_form .arfdropdown-menu.open' ).css( 'border-color', '' );
		jQuery( '#arf_postcreator_form_msg' ).css( 'display', 'none' );
	}

	if (jQuery( '#arf_postcreator_title' ).val() == '' &&  jQuery('input[name="arf_postcreator_post_type"]:checked').val() != 'buddypress_grp' && (jQuery( '#arfaction' ).val() == 'new' || jQuery( "#arfaction" ).val() == 'edit')) {
		jQuery( '.arf_postcreator_title .arfbtn.dropdown-toggle' ).css( 'border-color', '#FF0000' );
		jQuery( '.arf_postcreator_title .arfdropdown-menu.open' ).css( 'border-color', '#FF0000' );
		jQuery( '#arf_postcreator_title_msg' ).css( 'display', 'block' );
		req++;
	} else {
		jQuery( '.arf_postcreator_title .arfbtn.dropdown-toggle' ).css( 'border-color', '' );
		jQuery( '.arf_postcreator_title .arfdropdown-menu.open' ).css( 'border-color', '' );
		jQuery( '#arf_postcreator_title_msg' ).css( 'display', 'none' );
	}

	if (jQuery( '#arf_postcreator_description' ).val() == '' &&  jQuery('input[name="arf_postcreator_post_type"]:checked').val() == 'buddypress_grp' && (jQuery( '#arfaction' ).val() == 'new' || jQuery( "#arfaction" ).val() == 'edit')) {
		jQuery( '.arf_postcreator_description .arfbtn.dropdown-toggle' ).css( 'border-color', '#FF0000' );
		jQuery( '.arf_postcreator_description .arfdropdown-menu.open' ).css( 'border-color', '#FF0000' );
		jQuery( '#arf_postcreator_description_msg' ).css( 'display', 'block' );
		req++;
	} else {
		jQuery( '.arf_postcreator_description .arfbtn.dropdown-toggle' ).css( 'border-color', '' );
		jQuery( '.arf_postcreator_description .arfdropdown-menu.open' ).css( 'border-color', '' );
		jQuery( '#arf_postcreator_description_msg' ).css( 'display', 'none' );
	}

	if (jQuery( '#arf_postcreator_status' ).val() == '' && (jQuery( '#arfaction' ).val() == 'new' || jQuery( "#arfaction" ).val() == 'edit')) {
		jQuery( '.arf_postcreator_status .arfbtn.dropdown-toggle' ).css( 'border-color', '#ff0000' );
		jQuery( '.arf_postcreator_status .arfdropdown-menu.open' ).css( 'border-color', '#ff0000' );
		jQuery( '#arf_postcreator_status_msg' ).css( 'display', 'block' );
		req++;
	} else {
		jQuery( '.arf_postcreator_status .arfbtn.dropdown-toggle' ).css( 'border-color', '' );
		jQuery( '.arf_postcreator_status .arfdropdown-menu.open' ).css( 'border-color', '' );
		jQuery( '#arf_postcreator_statust_msg' ).css( 'display', 'none' );
	}
	if (jQuery( "#arf_postcreator_author" ).is( ':checked' ) == false && jQuery( "#arf_postcreator_author_list" ).val() == "" && (jQuery( '#arfaction' ).val() == 'new' || jQuery( "#arfaction" ).val() == 'edit')) {
		jQuery( '.arf_postcreator_author .arfbtn.dropdown-toggle' ).css( 'border-color', '#FF0000' );
		jQuery( '.arf_postcreator_author .arfdropdown-menu.open' ).css( 'border-color', '#FF0000' );
		jQuery( '#arf_postcreator_author_msg' ).css( 'display', 'block' );
		req++;
	} else {
		jQuery( '.arf_postcreator_author .arfbtn.dropdown-toggle' ).css( 'border-color', '' );
		jQuery( '.arf_postcreator_author .arfdropdown-menu.open' ).css( 'border-color', '' );
		jQuery( '#arf_postcreator_author_msg' ).css( 'display', 'none' );
	}
	if (jQuery( "input[type='checkbox']#arf_postcreator_date" ).is( ':checked' ) == false && jQuery( "#arf_postcreator_date_list" ).val() == "" && (jQuery( '#arfaction' ).val() == 'new' || jQuery( "#arfaction" ).val() == 'edit')) {
		jQuery( '.arf_postcreator_date .arfbtn.dropdown-toggle' ).css( 'border-color', '#FF0000' );
		jQuery( '.arf_postcreator_date .arfdropdown-menu.open' ).css( 'border-color', '#FF0000' );
		jQuery( '#arf_postcreator_date_msg' ).css( 'display', 'block' );
		req++;
	} else {
		jQuery( '.arf_postcreator_date .arfbtn.dropdown-toggle' ).css( 'border-color', '' );
		jQuery( '.arf_postcreator_date .arfdropdown-menu.open' ).css( 'border-color', '' );
		jQuery( '#arf_postcreator_date_msg' ).css( 'display', 'none' );
	}
	if (jQuery( "#custom_post_type_list" ).css( 'display' ) != 'none' && (jQuery( "#arfaction" ).val() == 'new' || jQuery( "#arfaction" ).val() == 'edit')) {
		if (jQuery( "#arf_postcreator_custom_post" ).val() == "") {
			jQuery( '.arf_postcreator_custom_post .arfbtn.dropdown-toggle' ).css( 'border-color', '#FF0000' );
			jQuery( '.arf_postcreator_custom_post .arfdropdown-menu.open' ).css( 'border-color', '#FF0000' );
			jQuery( "#arf_postcreator_custom_post_msg" ).css( 'display', 'block' );
			req++;
		} else {
			jQuery( '.arf_postcreator_custom_post .arfbtn.dropdown-toggle' ).css( 'border-color', '' );
			jQuery( '.arf_postcreator_custom_post .arfdropdown-menu.open' ).css( 'border-color', '' );
			jQuery( "#arf_postcreator_custom_post_msg" ).css( 'display', 'none' );
		}
	}

	if (jQuery('input[name="arf_postcreator_buddypress_grp[]"]:checked').length < 1 && jQuery('input[name="arf_postcreator_bp_group"]').val() == '' && jQuery('input[name="arf_postcreator_post_type"]:checked').val() == 'buddypress_grp' && (jQuery( "#arfaction" ).val() == 'new' || jQuery( "#arfaction" ).val() == 'edit')) {
		jQuery( "#arf_postcreator_bp_grp_msg" ).css( 'display', 'block' );
		req++;
	}else{
		jQuery( "#arf_postcreator_bp_grp_msg" ).css( 'display', 'none' );
	}

	if (req > 0) {
		jQuery( window.opera ? 'html' : 'html, body' ).animate(
			{
				scrollTop: jQuery( '#poststuff' ).offset().top - 250
			},
			'slow'
		);
		return false;
	}
	if (jQuery( '#custom_fields' ).html() != "") {
		jQuery( ".meta_row" ).each(
			function() {
				var str                = this.id;
				var str                = str.split( '_' );
				var id_no              = str[2];
				var counter_validation = 0;
				jQuery( "#" + this.id ).find( '.txtstandardnew' ).each(
					function() {
						if (jQuery( this ).val() == "") {
							jQuery( this ).css( 'border-color', '#FF0000' );
							jQuery( '#arf_postcreator_custom_field_msg_' + id_no ).css( 'display', 'block' );
							req++;
							counter_validation++;
						} else {
							jQuery( this ).css( 'border-color', '' );
						}
					}
				);
				jQuery( "#" + this.id ).find( '.sltstandard select' ).each(
					function() {
						if (jQuery( this ).val() == "") {
							jQuery( this ).css( 'border-color', '#FF0000' );
							jQuery( "#" + str ).find( '.arf_postcreator_custom_fields .btn.dropdown-toggle' ).css( 'border-color', '#FF0000' );
							jQuery( "#" + str ).find( '.arf_postcreator_custom_fields .arfdropdown-menu.open' ).css( 'border-color', '#FF0000' );
							jQuery( '#arf_postcreator_custom_field_msg_' + id_no ).css( 'display', 'block' );
							req++;
							counter_validation++;
						} else {
							jQuery( this ).css( 'border-color', '' );
							jQuery( "#" + str ).find( '.arf_postcreator_custom_fields .btn.dropdown-toggle' ).css( 'border-color', '' );
							jQuery( "#" + str ).find( '.arf_postcreator_custom_fields .arfdropdown-menu.open' ).css( 'border-color', '' );
						}
					}
				);
				if (counter_validation < 1) {
					jQuery( '#arf_postcreator_custom_field_msg_' + id_no ).css( 'display', 'none' );
				}
			}
		);
	}

	if (req > 0) {
		jQuery( window.opera ? 'html' : 'html, body' ).animate(
			{
				scrollTop: jQuery( '#arf_custom_fields' ).offset().top - 80
			},
			'slow'
		);
		return false;
	} else {

		var ajaxurl = jQuery( "#ajaxurl" ).val();
		var nonce   = jQuery( "#arfpostcreator_nonce" ).val();

		var formData = jQuery( "form#arf_postcreator_setting" ).serialize();

		jQuery.ajax(
			{
				url: ajaxurl,
				type:'post',
				dataType:'json',
				data:'action=arf_save_postcreator_data&_wpnonce_postcreator=' + nonce + '&' + formData,
				beforeSend: function(){
					jQuery('.arf_pc_save_loader').addClass('active');
				},
				success:function( msg ){
					jQuery('.arf_pc_save_loader').removeClass('active');
					if ( false == msg.success ) {
						jQuery( '#error_msg_text' ).html( msg.message );
						error_msg();
					} else {
						jQuery( '#message_desc_text' ).html( msg.message );
						success_msg();

						if ( 'new' == msg.arfaction ) {
							var pageurl = removeVariableFromURL( document.URL,'arfaction' );
							pageurl    += '&arfaction=edit&id=' + msg.id;
							jQuery("#arfaction").val( 'edit' );
							jQuery("#id").val( msg.id );
							window.history.pushState( {path: pageurl}, '', pageurl );
						}
					}
				},
				error:function(){
					jQuery('.arf_pc_save_loader').removeClass('active');
				}
			}
		);

		return false;
	}
}

function arf_postcreator_form_change() {
	var form_id = jQuery( '#arf_postcreator_form' ).val();
	jQuery( "#custom_fields" ).html( '' );
	jQuery( "#custom_fields_edit_mode" ).html( '' );
	jQuery( "#add_new_custom_field_edit_mode" ).show( 0 );
	jQuery( "#add_new_custom_field" ).show( 0 );
	jQuery( "#total_custom_fields" ).val( 0 );
	jQuery( "#last_custom_field_no" ).val( 0 );
	jQuery.ajax(
		{
			type: "POST",
			url: ajaxurl,
			data: "action=arf_postcreator_field_dropdown&form_id=" + form_id,
			success: function(msg) {
				jQuery( "#form_id" ).val( form_id );
				jQuery( '#all_fields_ul' ).html( msg );
				var arf_postcreator_fields_html                 = '';
				var arf_postcreator_file_fields_html            = '';
				var arf_postcreator_user_filled_categories_html = '';
				var arf_postcreator_user_filled_fields_html     = '';
				var arf_postcreator_user_filled_bp_group        = '';
				jQuery( '#all_fields_ul li' ).each(
					function(index, el) {
						var excluded_array_fields     = ['divider', 'captcha', 'break', 'html', 'like'];
						var excluded_array_file       = ['file'];
						var excluded_array_categories = ['radio', 'checkbox', 'select', 'arf_multiselect', 'arf_autocomplete'];
						var excluded_array_formates   = ['radio', 'select'];
						var excluded_array_bp_group   = ['radio', 'checkbox', 'select', 'arf_autocomplete', 'arf_multiselect'];
						var type                      = jQuery( this ).attr( 'data-type' );
						if (jQuery.inArray( type, excluded_array_fields ) == -1) {
							arf_postcreator_fields_html += jQuery( this ).prop( 'outerHTML' );
						}
						if (jQuery.inArray( type, excluded_array_file ) > -1) {
							arf_postcreator_file_fields_html += jQuery( this ).prop( 'outerHTML' );
						}
						if (jQuery.inArray( type, excluded_array_categories ) > -1) {
							arf_postcreator_user_filled_categories_html += jQuery( this ).prop( 'outerHTML' );
						}
						if (jQuery.inArray( type, excluded_array_formates ) > -1) {
							arf_postcreator_user_filled_fields_html += jQuery( this ).prop( 'outerHTML' );
						}
						if (jQuery.inArray( type, excluded_array_bp_group ) > -1) {
							arf_postcreator_user_filled_bp_group += jQuery( this ).prop( 'outerHTML' );
						}
					}
				);
				jQuery( '.arf_postcreator_fields' ).html( arf_postcreator_fields_html );
				jQuery( '.arf_postcreator_file_fields' ).html( arf_postcreator_file_fields_html );
				jQuery( '#arf_postcreator_category .arf_postcreator_user_filled_fields' ).html( arf_postcreator_user_filled_categories_html );
				jQuery( '#arf_postcreator_format .arf_postcreator_user_filled_fields' ).html( arf_postcreator_user_filled_fields_html );
				jQuery( '#arf_pc_bp_settings .arf_postcreator_bp_group').html(arf_postcreator_user_filled_bp_group);
			}
		}
	);
}

function removeVariableFromURL(url_string, variable_name) {
	var URL   = String( url_string );
	var regex = new RegExp( "\\?" + variable_name + "=[^&]*&?", "gi" );
	URL       = URL.replace( regex, '?' );
	regex     = new RegExp( "\\&" + variable_name + "=[^&]*&?", "gi" );
	URL       = URL.replace( regex, '&' );
	URL       = URL.replace( /(\?|&)$/, '' );
	regex     = null;
	return URL;
}

function is_default_author() {
	if (jQuery( '#arf_postcreator_author' ).is( ':checked' )) {
		jQuery( '#arf_postcreator_author_value' ).attr( 'disabled', true );
		jQuery( '#arf_postcreator_author_value' ).next( 'dl' ).children( 'dt' ).addClass( 'arf_disable_selectbox' );
		jQuery( '.arf_postcreator_author .dropdown-toggle' ).addClass( 'disabled' );
		jQuery( "#arf_postcreator_author_value" ).find( 'option' ).each(
			function() {
				jQuery( "#arf_postcreator_author_value" ).find( 'option' ).removeAttr( 'selected' );
			}
		);
		jQuery( "#arf_postcreator_author_value" ).find( 'option' ).first().attr( 'selected', 'selected' );
	} else {
		jQuery( '#arf_postcreator_author_value' ).attr( 'disabled', false );
		jQuery( '.arf_postcreator_author .dropdown-toggle' ).removeClass( 'disabled' );
		jQuery( '#arf_postcreator_author_value' ).next( 'dl' ).children( 'dt' ).removeClass( 'arf_disable_selectbox' );
	}
	/*jQuery( "#arf_postcreator_author_value" ).selectpicker( 'refresh' );*/
}

function is_default_date() {
	if (jQuery( '#arf_postcreator_date' ).is( ':checked' )) {
		jQuery( '#arf_postcreator_date_list' ).attr( 'disabled', true );
		jQuery( '#arf_postcreator_date_list' ).next( 'dl' ).children( 'dt' ).addClass( 'arf_disable_selectbox' );
		jQuery( '.arf_postcreator_date .dropdown-toggle' ).addClass( 'disabled' );
		jQuery( "#arf_postcreator_date_list" ).find( 'option' ).each(
			function() {
				jQuery( "#arf_postcreator_date_list" ).find( 'option' ).removeAttr( 'selected' );
			}
		);
		jQuery( "#arf_postcreator_date_list" ).find( 'option' ).first().attr( 'selected', 'selected' );
	} else {
		jQuery( '#arf_postcreator_date_list' ).attr( 'disabled', false );
		jQuery( '.arf_postcreator_date .dropdown-toggle' ).removeClass( 'disabled' );
		jQuery( '#arf_postcreator_date_list' ).next( 'dl' ).children( 'dt' ).removeClass( 'arf_disable_selectbox' );
	}
	/*jQuery( "#arf_postcreator_date_list" ).selectpicker( 'refresh' );*/
}

function arf_delete_close_popup(id) {
	jQuery( '.delete_form_message_' + id ).hide();
	if (jQuery( '.arfdeleteform_div_' + id ).parents( '.arf_action_cell' ).find( '.delete_form_message_' + id ).length > 0) {
		jQuery( '.arfdeleteform_div_' + id ).parents( '.arf_action_cell' ).find( '.delete_form_message_' + id ).remove();
	}
}
jQuery( document ).ready(
	function() {
		if (jQuery( "#arf_postcreator_author" ).is( ':checked' )) {
			jQuery( "#arf_postcreator_author_value" ).attr( 'disabled', true );
			jQuery( "#arf_postcreator_author_value" ).next( 'dl' ).children( 'dt' ).addClass( 'arf_disable_selectbox' );
			jQuery( ".arf_postcreator_author .dropdown-toggle" ).addClass( 'disabled' );
		} else {
			jQuery( "#arf_postcreator_author_value" ).attr( 'disabled', false );
			jQuery( '#arf_postcreator_author_value' ).next( 'dl' ).children( 'dt' ).removeClass( 'arf_disable_selectbox' );
			jQuery( ".arf_postcreator_author .dropdown-toggle" ).removeClass( 'disabled' );
		}
		if (jQuery( "#arf_postcreator_date" ).is( ':checked' )) {
			jQuery( '#arf_postcreator_date_list' ).attr( 'disabled', true );
			jQuery( '#arf_postcreator_date_list' ).next( 'dl' ).children( 'dt' ).addClass( 'arf_disable_selectbox' );
			jQuery( '.arf_postcreator_date .dropdown-toggle' ).addClass( 'disabled' );
		} else {
			jQuery( '#arf_postcreator_date_list' ).attr( 'disabled', false );
			jQuery( '#arf_postcreator_date_list' ).next( 'dl' ).children( 'dt' ).removeClass( 'arf_disable_selectbox' );
			jQuery( '.arf_postcreator_date .dropdown-toggle' ).removeClass( 'disabled' );
		}
		if (jQuery("#arf_postcreator_user_filled_formats").val() != '') {
			jQuery( ".arf_format_type_wrapper" ).find( '#arf_format_type' ).attr( 'disabled', 'disabled' );
			jQuery( ".arf_format_type_wrapper" ).find( 'ul.arfdropdown-menu li' ).addClass( 'disabled' );
			jQuery( ".arf_format_type_wrapper" ).find( 'dt' ).addClass( 'arf_disable_selectbox' );
		}else{
			jQuery( ".arf_format_type_wrapper" ).find( '#arf_format_type' ).removeAttr( 'disabled' );
			jQuery( ".arf_format_type_wrapper" ).find( 'ul.arfdropdown-menu li' ).removeClass( 'disabled' );
			jQuery( ".arf_format_type_wrapper" ).find( 'dt' ).removeClass( 'arf_disable_selectbox' );
		}
		if (jQuery('#arf_postcreator_bp_group_list').val() != '') {
			jQuery('#arf_postcreator_user_filled_group_main').find('.radiobutton input[type=checkbox]').attr('disabled', 'disabled');
		}else{
			jQuery('#arf_postcreator_user_filled_group_main').find('.radiobutton input[type=checkbox]').removeAttr('disabled');
		}

		if (jQuery( "#arfaction" ).val() != "") {
			if (jQuery( "#arfaction" ).val() == 'edit') {
				if (jQuery.trim( jQuery( "#custom_fields_edit_mode" ).html() ) != "") {
					jQuery( "button#add_new_custom_field_edit_mode" ).css( 'display', 'none' );
				} else {
					jQuery( "button#add_new_custom_field_edit_mode" ).css( 'display', 'block' );
				}
			} else if (jQuery( "#arfaction" ).val() == 'new') {
				if (jQuery.trim( jQuery( "#custom_fields" ).html() ) != "") {
					jQuery( "button#add_new_custom_field" ).css( 'display', 'none' );
				} else {
					jQuery( "button#add_new_custom_field" ).css( 'display', 'block' );
				}
			}
		}
		jQuery( "td" ).on(
			'click',
			'#add_new_custom_field',
			function() {
				add_post_meta_row( 1 )
			}
		);
		jQuery( "td" ).on(
			'click',
			'#add_new_custom_field_edit_mode',
			function() {
				edit_post_meta_row( 1 );
			}
		);
		setTimeout(
			function() {
				jQuery( "#arf_full_width_loader" ).hide();
			},
			500
		);

		wp.hooks.addFilter( 'arf_modify_datatable_action_outside', 'arfpostcreator', arf_modify_ajax_actions, 9 );

		if (jQuery.isFunction( jQuery().tooltipster )) {
			setTimeout(
				function() {
					jQuery( '.arfhelptip' ).tooltipster(
						{
							theme: 'arf_admin_tooltip',
							position: 'top',
							contentAsHTML: true,
							onlyOne: true,
							multiple: true,
							maxWidth: 400,
						}
					);
				},
				10
			);
		}

		if (0 < jQuery( '.arf_postcreator_list_form' ).length) {
			arf_initialize_post_creator_list();
		}

		jQuery( "#cb-select-all-1" ).click(
			function() {
				jQuery( 'input[name="item-action[]"]' ).prop( 'checked', this.checked );
			}
		);
		jQuery( 'input[name="item-action[]"]' ).click(
			function() {
				if (jQuery( 'input[name="item-action[]"]' ).length == jQuery( 'input[name="item-action[]"]:checked' ).length) {
					jQuery( "#cb-select-all-1" ).prop( "checked", true );
				} else {
					jQuery( "#cb-select-all-1" ).prop( "checked", false );
				}
			}
		);

		if ( '' != jQuery( '#error_msg_text' ).html() ) {
			error_msg();

			var pageurl = removeVariableFromURL( document.URL,'err' );
			window.history.pushState( {path: pageurl}, '', pageurl );
		}

		if ( jQuery( "#arf_postcreator_error" ).length > 0 ) {
			var url              = jQuery( "#arf_postcreator_error" ).attr( 'data-url' );
			window.location.href = url;
		}
	}
);
jQuery( document ).on(
	'click',
	'.arf_post_creator_delete',
	function(event) {
		var id = jQuery( this ).attr( 'data-id' );
		if (id == null || id == 'undefined') {
			return;
		}
		var delete_popup_html = '';
		delete_popup_html    += '<div class="delete_popup arfactive delete_form_message_' + id + '" id="delete_form_message">';
		delete_popup_html    += '<input type="hidden" value="' + id + '" id="delete_entry_id"/>';
		delete_popup_html    += '<div class="delete_column_arrow" style="position:absolute;"></div>';
		delete_popup_html    += '<div class="delete_title"><div class="delete_confirm_message">Are you sure you want to </br> delete this configuration?</div>';
		delete_popup_html    += '<div class="delete_popup_footer">';
		delete_popup_html    += '<button type="button" class="rounded_button add_button arf_delete_modal_left arfdelete_color_red" onclick="arfpostcreatorformactionfunc(\'delete\',' + id + ');">Delete</button>&nbsp;&nbsp;';
		delete_popup_html    += '<button type="button" class="rounded_button delete_button arfdelete_color_gray" onclick="arf_delete_close_popup(' + id + ');">Cancel</button>';
		delete_popup_html    += '</div>';
		delete_popup_html    += '</div>';
		delete_popup_html    += '</div>';
		var select_content    = jQuery( this ).parent().parent( '.arf-row-actions' );
		jQuery( delete_popup_html ).insertAfter( select_content );
		jQuery( '.delete_form_message_' + id ).show();
	}
);
var $custom_field_cnt;
$custom_field_cnt = 0;

function add_post_meta_row(is_blank_meta) {
	$custom_field_cnt++;
	if (jQuery( '.arf_postcreator_blank_field_msg' ).is( ':visible' )) {
		jQuery( '.arf_postcreator_blank_field_msg' ).css( 'display', 'none' );
	}
	if (document.getElementById( "arf_postcreator_form" )) {
		var form_id = jQuery( '#arf_postcreator_form' ).val();
	} else {
		form_id = jQuery( '#form_id' ).val();
	}
	if (form_id == '' || form_id == 0) {
		jQuery( '#arf_postcreator_custom_field_msg' ).css( 'display', 'block' );
		return false;
	}
	var fields           = jQuery( "#total_custom_fields" ).val();
	var arfaction        = jQuery( "#arfaction" ).val();
	var last_field       = jQuery( "#last_custom_field_no" ).val();
	var curr_post_type   = "basic";
	var custom_post_type = "";
	if (jQuery( "#arf_post_type_custom" ).prop( 'checked' ) == true) {
		curr_post_type   = "custom";
		custom_post_type = jQuery( "#arf_postcreator_custom_post" ).val();
	}
	if (jQuery( "#arf_post_type_page" ).prop( 'checked' ) == true) {
		curr_post_type = "page";
	}
	jQuery.ajax(
		{
			type: 'POST',
			url: ajaxurl,
			data: 'action=add_custom_field&form_id=' + form_id + "&field_no=" + last_field + "&frm_action=" + arfaction + "&is_blank_meta=" + is_blank_meta + "&curr_post_type=" + curr_post_type + "&custom_post_type=" + custom_post_type + "&custom_field_count=" + $custom_field_cnt,
			success: function(res) {
				if (res == '' || res == 0) {
					jQuery( '#arf_postcreator_custom_field_msg' ).css( 'display', 'block' );
					return false;
				} else {
					jQuery( "#custom_fields" ).append( res );
					jQuery( '#arf_postcreator_custom_field_msg' ).css( 'display', 'none' );
					/*jQuery( ".sltstandard select" ).selectpicker();*/
					jQuery( "#total_custom_fields" ).val( parseInt( fields ) + 1 );
					jQuery( "#last_custom_field_no" ).val( parseInt( last_field ) + 1 );
					if (arfaction == 'new') {
						if (jQuery( "#custom_fields" ).html().trim() != "") {
							jQuery( "button#add_new_custom_field" ).css( 'display', 'none' );
						} else {
							jQuery( "button#add_new_custom_field" ).css( 'display', 'block' );
						}
					} else {
						if (jQuery( "#custom_fields_edit_mode" ).html().trim() == "") {
							jQuery( "#buttom#add_new_custom_field_edit_mode" ).css( 'display', 'block' );
						} else {
							jQuery( "#buttom#add_new_custom_field_edit_mode" ).css( 'display', 'none' );
						}
					}
				}
			}
		}
	);
}

function edit_post_meta_row(is_blank_meta) {
	if (jQuery( '.arf_postcreator_blank_field_msg' ).is( ':visible' )) {
		jQuery( '.arf_postcreator_blank_field_msg' ).css( 'display', 'none' );
	}
	var form_id          = jQuery( "#form_id" ).val();
	var fields           = jQuery( "#total_custom_fields" ).val();
	var last_field       = jQuery( "#last_custom_field_no" ).val();
	var arfaction        = jQuery( "#arfaction" ).val();
	var curr_post_type   = "basic";
	var custom_post_type = "";
	if (jQuery( "#arf_post_type_custom" ).prop( 'checked' ) == true) {
		curr_post_type   = "custom";
		custom_post_type = jQuery( "#arf_postcreator_custom_post" ).val();
	}
	if (jQuery( "#arf_post_type_page" ).prop( 'checked' ) == true) {
		curr_post_type = "page";
	}
	if (form_id == '' || form_id == 0) {
		jQuery( '#arf_postcreator_custom_field_msg' ).css( 'display', 'block' );
		return false;
	}
	var action    = "";
	var field_cnt = jQuery( '#last_custom_field_no' ).val();
	jQuery.ajax(
		{
			type: 'POST',
			url: ajaxurl,
			data: 'action=add_custom_field&form_id=' + form_id + "&field_no=" + last_field + "&frm_action=" + arfaction + "&is_blank_meta=" + is_blank_meta + "&curr_post_type=" + curr_post_type + "&custom_post_type=" + custom_post_type + "&custom_field_count=" + field_cnt,
			success: function(res) {
				if (res == '' || res == 0) {
					jQuery( '#arf_postcreator_custom_field_msg' ).css( 'display', 'block' );
					return false;
				} else {
					jQuery( "#custom_fields_edit_mode" ).append( res );
					jQuery( '#arf_postcreator_custom_field_msg' ).css( 'display', 'none' );
					/*jQuery( ".sltstandard select" ).selectpicker();*/
					jQuery( "#total_custom_fields" ).val( parseInt( fields ) + 1 );
					jQuery( "#last_custom_field_no" ).val( parseInt( last_field ) + 1 );
					if (arfaction == 'new') {
						if (jQuery( "#custom_fields" ).html().trim() != "") {
							jQuery( "button#add_new_custom_field" ).css( 'display', 'none' );
						} else {
							jQuery( "button#add_new_custom_field" ).css( 'display', 'block' );
						}
					} else {
						if (jQuery( "#custom_fields_edit_mode" ).html().trim() != "") {
							jQuery( "button#add_new_custom_field_edit_mode" ).css( 'display', 'none' );
						} else {
							jQuery( "button#add_new_custom_field_edit_mode" ).css( 'display', 'block' );
						}
					}
				}
			}
		}
	);
}

function remove_meta_row(tag, id) {
	jQuery( tag ).remove();
	var fields = jQuery( "#total_custom_fields" ).val();
	jQuery( "#total_custom_fields" ).val( parseInt( fields ) - 1 );
	var total     = jQuery( "#total_custom_fields" ).val();
	var arfaction = jQuery( "#arfaction" ).val();
	var pre_id    = parseInt( id ) - 1;
	if (arfaction == 'new') {
		if (jQuery( "#custom_fields" ).html().trim() == "") {
			jQuery( "button#add_new_custom_field" ).css( 'display', 'block' );
		}
	} else {
		if (jQuery( "#custom_fields_edit_mode" ).html().trim() == "" && arfaction == 'edit') {
			jQuery( "button#add_new_custom_field_edit_mode" ).css( 'display', 'block' );
		}
	}

	if ( total == 0 ) {
		jQuery('.arf_postcreator_blank_field_msg').removeAttr('style');
	}
}
jQuery( document ).ready(
	function() {
		if (jQuery( "#arf_post_type_custom" ).prop('checked') == true) {
			jQuery( "#custom_post_type_list" ).css( 'display', 'table-row' );
			jQuery( "#custom_post_fields" ).css( 'display', 'table-row' );
			jQuery( "#arf_postcreator_tags" ).css( 'display', 'none' );
			jQuery( "#buddypress_grp_post_type_list" ).css('display', 'none');
			jQuery( "#arf_pc_bp_settings" ).parent().css('display', 'none');
			jQuery( "#advance_field_section_wrap" ).css('display', 'table-row');
			jQuery( ".arf_pc_allow_comment_wrap" ).css('display', 'table-row');
			jQuery( "#arf_description_req" ).addClass('arf_pc_display_none');
		} else if (jQuery( "#arf_post_type_page" ).prop('checked') == true) {
			jQuery( "#custom_post_type_list" ).css( 'display', 'none' );
			jQuery( "#custom_post_fields" ).css( 'display', 'none' );
			jQuery( "#buddypress_grp_post_type_list" ).css('display', 'none');
			jQuery( "#arf_postcreator_category" ).parent().css( 'display', 'none' );
			jQuery( "#arf_postcreator_format" ).parent().css( 'display', 'none' );
			jQuery( "#arf_pc_bp_settings" ).parent().css('display', 'none');
			jQuery( "#arf_postcreator_tags" ).css( 'display', 'none' );
			jQuery( "#arf_postcreator_excerpt_main" ).css( 'display', 'none' );
			jQuery( "#advance_field_section_wrap" ).css('display', 'table-row');
			jQuery( ".arf_pc_allow_comment_wrap" ).css('display', 'table-row');
			jQuery( "#arf_description_req" ).addClass('arf_pc_display_none');
		} else if(jQuery('input[name="arf_postcreator_post_type"]:checked').val() == 'buddypress_grp'){

			jQuery("#buddypress_grp_post_type_list").css('display', 'table-row');
			jQuery( "#arf_pc_bp_settings" ).parent().css('display', 'table-row');
			jQuery( "#advance_field_section_wrap" ).css('display', 'none');
			jQuery( ".arf_pc_allow_comment_wrap" ).css('display', 'none');
			jQuery( "#custom_post_type_list" ).css( 'display', 'none' );
			jQuery( "#custom_post_fields" ).css( 'display', 'none' );
			jQuery( "#arf_postcreator_category" ).parent().css( 'display', 'none' );
			jQuery( "#arf_postcreator_format" ).parent().css( 'display', 'none' );
			jQuery( "#arf_postcreator_tags" ).css( 'display', 'none' );
			jQuery( "#arf_postcreator_excerpt_main" ).css( 'display', 'none' );
			jQuery( "#arf_description_req" ).removeClass('arf_pc_display_none');
		} else {
			jQuery( "#custom_post_type_list" ).css( 'display', 'none' );
			jQuery( "#buddypress_grp_post_type_list" ).css('display', 'none');
			jQuery( "#custom_post_fields" ).css( 'display', 'none' );
			jQuery( "#arf_postcreator_tags" ).css( 'display', 'table-row' );
			jQuery( "#arf_pc_bp_settings" ).parent().css('display', 'none');
			jQuery( "#advance_field_section_wrap" ).css('display', 'table-row');
			jQuery( ".arf_pc_allow_comment_wrap" ).css('display', 'table-row');
			jQuery( "#arf_description_req" ).addClass('arf_pc_display_none');
		}
		if (jQuery( "#arf_post_type_custom" ).prop( 'checked' ) == true) {
			jQuery( "#custom_post_type_list" ).css( 'display', 'table-row' );
			jQuery( "#custom_post_fields" ).css( 'display', 'table-row' );
			jQuery( "#arf_postcreator_tags" ).css( 'display', 'none' );
			jQuery( "#advance_field_section_wrap" ).css('display', 'table-row');
			jQuery( ".arf_pc_allow_comment_wrap" ).css('display', 'table-row');
			jQuery( "#arf_description_req" ).addClass('arf_pc_display_none');
		} else if (jQuery( "#arf_post_type_page" ).prop( 'checked' ) == true) {
			jQuery( "#custom_post_type_list" ).css( 'display', 'none' );
			jQuery( "#custom_post_fields" ).css( 'display', 'none' );
			jQuery( "#arf_postcreator_category" ).parent().css( 'display', 'none' );
			jQuery( "#arf_postcreator_format" ).parent().css( 'display', 'none' );
			jQuery( "#arf_postcreator_tags" ).css( 'display', 'none' );
			jQuery( "#arf_postcreator_excerpt_main" ).css( 'display', 'none' );
			jQuery( "#advance_field_section_wrap" ).css('display', 'table-row');
			jQuery( ".arf_pc_allow_comment_wrap" ).css('display', 'table-row');
			jQuery( "#arf_description_req" ).addClass('arf_pc_display_none');
		} else {
			jQuery( "#arf_postcreator_tags" ).css( 'display', 'table-row' );
		}
		if (jQuery( "#arf_postcreator_category" ).html()) {
			if (jQuery( "#arf_postcreator_category" ).html().trim() == "") {
				jQuery( "#arf_postcreator_category" ).parent().css( 'display', 'none' );
			} else {
				if (jQuery( "#arf_post_type_page" ).prop( 'checked' ) != true) {
					jQuery( "#arf_postcreator_category" ).parent().css( 'display', 'block' );
				}else if (jQuery('input[name="arf_postcreator_post_type"]:checked').val() != 'buddypress_grp') {
					jQuery( "#arf_postcreator_category" ).parent().css( 'display', 'block' );
				}
			}
		}
	}
);

function is_checked(id, status) {
	var form_id = jQuery( "#form_id" ).val();
	jQuery( "#custom_fields" ).html( '' );
	jQuery( "#custom_fields_edit_mode" ).html( '' );
	jQuery( "#add_new_custom_field_edit_mode" ).show( 0 );
	jQuery( "#add_new_custom_field" ).show( 0 );
	jQuery( "#arf_postcreator_category" ).parent().css( 'display', 'table-row' );
	jQuery( "#arf_postcreator_format" ).parent().css( 'display', 'table-row' );
	jQuery( "#arf_postcreator_tags" ).css( 'display', 'table-row' );
	jQuery( "#arf_postcreator_excerpt_main" ).css( 'display', 'table-row' );
	jQuery( "#arf_description_req" ).addClass('arf_pc_display_none');
	if (id == 'arf_post_type_custom' && status == true) {
		jQuery( "#custom_post_type_list" ).css( 'display', 'table-row' );
		jQuery( "#buddypress_grp_post_type_list" ).css( 'display', 'none' );
		jQuery( "#advance_field_section_wrap" ).css('display', 'table-row');
		jQuery( ".arf_pc_allow_comment_wrap" ).css('display', 'table-row');
		jQuery( ".arf_post_custom_fields" ).css('display', 'table-row');
		jQuery( "#arf_description_req" ).addClass('arf_pc_display_none');
	} else if (id == 'arf_post_type_buddypress_grp' && status == true) {
		jQuery( "#arf_pc_bp_settings" ).parent().css('display', 'table-row');
		jQuery( "#buddypress_grp_post_type_list" ).css( 'display', 'table-row' );
		jQuery( "#arf_postcreator_category" ).parent().css( 'display', 'none' );
		jQuery( "#custom_post_fields" ).css( 'display', 'none' );
		jQuery( "#custom_post_type_list" ).css( 'display', 'none' );
		jQuery( "#arf_postcreator_format" ).parent().css( 'display', 'none' );
		jQuery( "#arf_postcreator_tags" ).css( 'display', 'none' );
		jQuery( "#arf_postcreator_excerpt_main" ).css( 'display', 'none' );
		jQuery( "#advance_field_section_wrap" ).css( 'display', 'none' );
		jQuery( ".arf_pc_allow_comment_wrap" ).css('display', 'none');
		jQuery( ".arf_post_custom_fields" ).css('display', 'none');
		jQuery( "#arf_pc_bp_settings" ).parent().css( 'border-bottom', 'none' );
		jQuery( "#arf_description_req" ).removeClass('arf_pc_display_none');
	} else if (id == 'arf_post_type_page' && status == true) {
		jQuery( "#custom_post_type_list" ).css( 'display', 'none' );
		jQuery( "#custom_post_fields" ).css( 'display', 'none' );
		jQuery( "#buddypress_grp_post_type_list" ).css( 'display', 'none' );
		jQuery( "#arf_postcreator_category" ).parent().css( 'display', 'none' );
		jQuery( "#arf_postcreator_format" ).parent().css( 'display', 'none' );
		jQuery( "#arf_postcreator_tags" ).css( 'display', 'none' );
		jQuery( "#arf_postcreator_excerpt_main" ).css( 'display', 'none' );
		jQuery( "#arf_pc_bp_settings" ).parent().css('display', 'none');
		jQuery( "#advance_field_section_wrap" ).css('display', 'table-row');
		jQuery( ".arf_pc_allow_comment_wrap" ).css('display', 'table-row');
		jQuery( "#arf_description_req" ).addClass('arf_pc_display_none');
		jQuery( ".arf_post_custom_fields" ).css('display', 'table-row');
	} else {
		jQuery( "#custom_post_type_list" ).css( 'display', 'none' );
		jQuery( "#buddypress_grp_post_type_list" ).css( 'display', 'none' );
		jQuery( "#custom_post_fields" ).css( 'display', 'none' );
		jQuery( "#arf_postcreator_tags" ).css( 'display', 'table-row' );
		jQuery( "#arf_pc_bp_settings" ).parent().css('display', 'none');
		jQuery( "#advance_field_section_wrap" ).css('display', 'table-row');
		jQuery( ".arf_pc_allow_comment_wrap" ).css('display', 'table-row');
		jQuery( ".arf_post_custom_fields" ).css('display', 'table-row');
		jQuery( "#arf_description_req" ).addClass('arf_pc_display_none');
		var details = ['basic', form_id];
		get_custom_post_categories( details );
	}
}

function get_custom_post_categories(query_var) {
	var form_id = jQuery( "#form_id" ).val();
	jQuery( "#custom_fields" ).html( '' );
	jQuery( "#custom_fields_edit_mode" ).html( '' );
	jQuery( "#add_new_custom_field_edit_mode" ).show( 0 );
	jQuery( "#add_new_custom_field" ).show( 0 );
	jQuery( "#custom_fields" ).html( '' );
	jQuery( "#custom_fields_edit_mode" ).html( '' );
	jQuery( "#add_new_custom_field_edit_mode" ).show( 0 );
	jQuery( "#add_new_custom_field" ).show( 0 );
	if (form_id == "") {
		jQuery.ajax(
			{
				type: 'POST',
				url: ajaxurl,
				data: 'action=arf_postcreator_get_custom_categories_new&form_id=' + form_id + '&query_var=' + query_var[0],
				success: function(msg) {
					jQuery( "#arf_postcreator_category" ).html( msg );
					/*jQuery( "#arf_postcreator_category" ).selectpicker( 'refresh' );*/
					/*jQuery( ".sltstandard select" ).selectpicker();*/
					if (jQuery( "#arf_postcreator_category" ).html().trim() == "") {
						jQuery( "#arf_postcreator_category" ).parent().css( 'display', 'none' );
					} else {
						jQuery( "#arf_postcreator_category" ).parent().css( 'display', 'block' );
					}
				}
			}
		);
	} else {
		jQuery.ajax(
			{
				type: 'POST',
				url: ajaxurl,
				data: 'action=arf_postcreator_get_custom_categories&query_var=' + query_var[0] + "&form_id=" + form_id,
				success: function(msg) {
					if (jQuery( "#arf_post_type_basic" ).is( ':checked' ) == true || jQuery( "#arf_post_type_custom" ).is( ':checked' ) == true) {
						if (msg.trim() != "" && query_var[0] != "") {
							jQuery( "#arf_postcreator_category" ).parent().css( 'display', 'block' );
							jQuery( "#arf_postcreator_category" ).html( msg );
							/*jQuery( "#arf_postcreator_category" ).selectpicker( 'refresh' );*/
							/*jQuery( ".sltstandard select" ).selectpicker();*/
						} else {
							jQuery( "#arf_postcreator_category" ).parent().css( 'display', 'none' );
						}
					}
				}
			}
		);
	}
}

function is_category_selected(value, parent_id) {
	var main_id = "#" + parent_id;
	if (value != "") {
		jQuery( main_id ).find( '.radiobutton' ).each(
			function() {
				jQuery( this ).find( 'input' ).attr( 'disabled', 'disabled' );
			}
		);
	} else {
		jQuery( main_id ).find( '.radiobutton' ).each(
			function() {
				jQuery( this ).find( 'input' ).removeAttr( 'disabled' );
			}
		);
	}
}

function is_group_selected(value, parent_id){
	var main_id = "#" + parent_id;
	if (value != '') {
		jQuery(main_id).find('.radiobutton').each(function(){
			jQuery( this ).find('input').attr('disabled', 'disabled');
		});
	}else{
		jQuery(main_id).find('.radiobutton').each(function(){
			jQuery(this).find('input').removeAttr('disabled');
		});
	}
}

function arf_modify_ajax_actions(actions_list){
	var pc_action_list = ['arf_retrieve_postcreator_config_data'];
	actions_list = actions_list.concat(pc_action_list);
	return actions_list;
}

function is_format_selected(value, parent_id) {
	var main_id = "#" + parent_id;
	if (value != "") {
		jQuery( main_id ).find( ".arf_format_type_wrapper" ).find( '#arf_format_type' ).attr( 'disabled', 'disabled' );
		jQuery( main_id ).find( ".arf_format_type_wrapper" ).find( 'ul.arfdropdown-menu li' ).addClass( 'disabled' );
		jQuery( main_id ).find(".arf_format_type_wrapper" ).find( 'dt' ).addClass( 'arf_disable_selectbox' );
	} else {
		jQuery( main_id ).find( ".arf_format_type_wrapper" ).find( '#arf_format_type' ).removeAttr( 'disabled' );
		jQuery( main_id ).find( ".arf_format_type_wrapper" ).find( 'ul.arfdropdown-menu li' ).removeClass( 'disabled' );
		jQuery( main_id ).find(".arf_format_type_wrapper" ).find( 'dt' ).removeClass( 'arf_disable_selectbox' );
	}
}

function arf_initialize_post_creator_list() {
	jQuery.fn.dataTableExt.oPagination.four_button = {
		"fnInit": function(oSettings, nPaging, fnCallbackDraw) {
			nFirst               = document.createElement( 'span' );
			nPrevious            = document.createElement( 'span' );
			var nInput           = document.createElement( 'input' );
			var nPage            = document.createElement( 'span' );
			var nOf              = document.createElement( 'span' );
			nOf.className        = "paginate_of";
			nInput.className     = "current_page_no";
			nPage.className      = "paginate_page";
			nInput.type          = "text";
			nInput.style.width   = "40px";
			nInput.style.height  = "26px";
			nInput.style.display = "inline";
			nPaging.appendChild( nPage );
			jQuery( nInput ).keyup(
				function(e) {
					if (e.which == 38 || e.which == 39) {
						this.value++;
					} else if ((e.which == 37 || e.which == 40) && this.value > 1) {
						this.value--;
					}
					if (this.value == "" || this.value.match( /[^0-9]/ )) {
						return;
					}
					var iNewStart = oSettings._iDisplayLength * (this.value - 1);
					if (iNewStart > oSettings.fnRecordsDisplay()) {
						oSettings._iDisplayStart = (Math.ceil( (oSettings.fnRecordsDisplay() - 1) / oSettings._iDisplayLength ) - 1) * oSettings._iDisplayLength;
						fnCallbackDraw( oSettings );
						return;
					}
					oSettings._iDisplayStart = iNewStart;
					fnCallbackDraw( oSettings );
				}
			);
			var nNext                          = document.createElement( 'span' );
			var nLast                          = document.createElement( 'span' );
			var nFirst                         = document.createElement( 'span' );
			var nPrevious                      = document.createElement( 'span' );
			var nPage                          = document.createElement( 'span' );
			var nOf                            = document.createElement( 'span' );
			nNext.style.backgroundRepeat       = "no-repeat";
			nNext.style.backgroundPosition     = "center";
			nNext.title                        = "Next";
			nLast.style.backgroundRepeat       = "no-repeat";
			nLast.style.backgroundPosition     = "center";
			nLast.title                        = "Last";
			nFirst.style.backgroundRepeat      = "no-repeat";
			nFirst.style.backgroundPosition    = "center";
			nFirst.title                       = "First";
			nPrevious.style.backgroundRepeat   = "no-repeat";
			nPrevious.style.backgroundPosition = "center";
			nPrevious.title                    = "Previous";
			nFirst.appendChild( document.createTextNode( ' ' ) );
			nPrevious.appendChild( document.createTextNode( ' ' ) );
			nLast.appendChild( document.createTextNode( ' ' ) );
			nNext.appendChild( document.createTextNode( ' ' ) );
			nOf.className = "paginate_button nof";
			nPaging.appendChild( nFirst );
			nPaging.appendChild( nPrevious );
			nPaging.appendChild( nInput );
			nPaging.appendChild( nOf );
			nPaging.appendChild( nNext );
			nPaging.appendChild( nLast );
			jQuery( nFirst ).click(
				function() {
					oSettings.oApi._fnPageChange( oSettings, "first" );
					fnCallbackDraw( oSettings );
				}
			);
			jQuery( nPrevious ).click(
				function() {
					oSettings.oApi._fnPageChange( oSettings, "previous" );
					fnCallbackDraw( oSettings );
				}
			);
			jQuery( nNext ).click(
				function() {
					oSettings.oApi._fnPageChange( oSettings, "next" );
					fnCallbackDraw( oSettings );
				}
			);
			jQuery( nLast ).click(
				function() {
					oSettings.oApi._fnPageChange( oSettings, "last" );
					fnCallbackDraw( oSettings );
				}
			);
			jQuery( nFirst ).bind(
				'selectstart',
				function() {
					return false;
				}
			);
			jQuery( nPrevious ).bind(
				'selectstart',
				function() {
					return false;
				}
			);
			jQuery( 'span', nPaging ).bind(
				'mousedown',
				function() {
					return false;
				}
			);
			jQuery( 'span', nPaging ).bind(
				'selectstart',
				function() {
					return false;
				}
			);
			jQuery( nNext ).bind(
				'selectstart',
				function() {
					return false;
				}
			);
			jQuery( nLast ).bind(
				'selectstart',
				function() {
					return false;
				}
			);
		},
		"fnUpdate": function(oSettings, fnCallbackDraw) {
			if ( ! oSettings.aanFeatures.p) {
				return;
			}
			var an = oSettings.aanFeatures.p;
			for (var i = 0, iLen = an.length; i < iLen; i++) {
				var buttons = an[i].getElementsByTagName( 'span' );
				if (oSettings._iDisplayStart === 0) {
					buttons[1].className = "paginate_disabled_first arfhelptip";
					buttons[2].className = "paginate_disabled_previous arfhelptip";
				} else {
					buttons[1].className = "paginate_enabled_first arfhelptip";
					buttons[2].className = "paginate_enabled_previous arfhelptip";
				}
				if (oSettings.fnDisplayEnd() == oSettings.fnRecordsDisplay()) {
					buttons[4].className = "paginate_disabled_next arfhelptip";
					buttons[5].className = "paginate_disabled_last arfhelptip";
				} else {
					buttons[4].className = "paginate_enabled_next arfhelptip";
					buttons[5].className = "paginate_enabled_last arfhelptip";
				}
				if ( ! oSettings.aanFeatures.p) {
					return;
				}
				var iPages       = Math.ceil( (oSettings.fnRecordsDisplay()) / oSettings._iDisplayLength );
				var iCurrentPage = Math.ceil( oSettings._iDisplayStart / oSettings._iDisplayLength ) + 1;
				if (document.getElementById( 'of_grid' )) {
					var of_grid = document.getElementById( 'of_grid' ).value;
				} else {
					var of_grid = 'of';
				}
				var an = oSettings.aanFeatures.p;
				for (var i = 0, iLen = an.length; i < iLen; i++) {
					var spans                         = an[i].getElementsByTagName( 'span' );
					var inputs                        = an[i].getElementsByTagName( 'input' );
					spans[spans.length - 3].innerHTML = " " + of_grid + " " + iPages
					inputs[0].value                   = iCurrentPage;
				}
			}
		}
	}
	var dt_obj = {
		"sDom": '<"H"lfr>t<"footer"ip>',
		"sPaginationType": "four_button",
		"bJQueryUI": true,
		"bPaginate": true,
		"bAutoWidth": false,
		"ordering": true,
        "order":[[1,'desc']],
		"oColVis": {
			"aiExclude": [0, 5]
		},
	};
	if( __ARF_DB_VERSION > 4.1 ){
		dt_obj.language = {
			"searchPlaceholder":__ARF_SEARCH_PLACEHOLDER,
			"search":""
		}
	}
	if( __ARF_DB_VERSION > 5.0 ){

		dt_obj.bProcessing = true;
        dt_obj.bServerSide = true;
        dt_obj.sAjaxSource = ajaxurl;
        dt_obj.sServerMethod = "POST";
        dt_obj.fnServerParams = function (aoData) {
            aoData.push(
            	{'name': 'action', 'value': 'arf_retrieve_postcreator_config_data'},
            );
        };
        dt_obj.fnPreDrawCallback = function () {
            jQuery("#arf_full_width_loader").show();
        };
        dt_obj.fnDrawCallback = function (oSettings) {
            jQuery("#arf_full_width_loader").hide();
            jQuery('.arfhelptip').tipso('destroy');
            jQuery('.arfhelptip').tipso({
                position: 'top',
                maxWidth: '400',
                useTitle: true,
                background: '#444444',
                color: '#ffffff',
                width: 'auto'
            });
        };
        dt_obj.aoColumnDefs = [
            {"bSortable": false, "aTargets": [0]},
            {"sClass": "center","aTargets":[0]}, 
            {"sClass": "sorting_1","aTargets":[1]}, 
            {"sClass": "form_name","aTargets":[2]}, 
            {"sClass": "form_entries center","aTargets":[3]},
            {"sClass": "arf_action_cell","aTargets":[6]} 
        ];

	}else{

		dt_obj.aoColumnDefs = [{
			"bVisible": false,
			"aTargets": []
		}, {
			"bSortable": false,
			"aTargets": [0, 5]
		}];

		dt_obj.fnDrawCallback = function (oSettings) {
            jQuery("#arf_full_width_loader").hide();
            jQuery('.arfhelptip').tipso({
                position: 'top',
                maxWidth: '400',
                useTitle: true,
                background: '#444444',
                color: '#ffffff',
                width: 'auto'
            });
        };

	}

	jQuery( ".arf_postcreator_list_form #example" ).dataTable(dt_obj);
}
function arf_delete_bulk_postcreator_form(is_delete){

    if( is_delete ){
        var str = jQuery('#arf_postcreator_forms').serialize();
        jQuery.ajax({
            type: "POST",
            url: ajaxurl,
            data: "action=arf_postcreator_form_bulk_act&" + str,
            dataType : 'json',
            beforeSend: function() {
                jQuery(".arf_loader_icon_wrapper").show();
            },
            success: function(msg) {
                jQuery(".arf_loader_icon_wrapper").hide();

                if ( 0 < msg.errors.length ) {
					jQuery( '#error_msg_text' ).html( msg.errors[0] );
					error_msg();
				}else{

					jQuery( "#success_msg_text" ).html( msg.message );
					success_msg();

					var ProductTable = jQuery( "#arf_postcreator_forms #example" ).DataTable();

					if( __ARF_DB_VERSION > 5.0 ){

						if( __ARF_DB_VERSION < 4.2 ){
							ProductTable.fnClearTable();
							ProductTable.fnDestroy();
						} else {
							ProductTable.clear();
							ProductTable.destroy();
						}

						var dt_obj = {
							"sDom": '<"H"lfr>t<"footer"ip>',
							"sPaginationType": "four_button",
							"bJQueryUI": true,
							"bPaginate": true,
							"bAutoWidth": false,
							"aoColumnDefs": [{
								"bVisible": false,
								"aTargets": []
							}, {
								"bSortable": false,
								"aTargets": [0, 5]
							}],
							"ordering": true,
							"order":[[1,'desc']],
							"oColVis": {
								"aiExclude": [0, 5]
							},
						}

						if( __ARF_DB_VERSION > 4.1 ){
							dt_obj.language = {
								"searchPlaceholder":__ARF_SEARCH_PLACEHOLDER,
								"search":""
							}
						}

						dt_obj.bProcessing = true;
						dt_obj.bServerSide = true;
						dt_obj.sAjaxSource = ajaxurl;
						dt_obj.sServerMethod = "POST";
						dt_obj.fnServerParams = function (aoData) {
						    aoData.push(
						    	{'name': 'action', 'value': 'arf_retrieve_postcreator_config_data'},
						    );
						};
						dt_obj.fnPreDrawCallback = function () {
						    jQuery("#arf_full_width_loader").show();
						};
						dt_obj.fnDrawCallback = function (oSettings) {
						    jQuery("#arf_full_width_loader").hide();
						    jQuery('.arfhelptip').tipso('destroy');
						    jQuery('.arfhelptip').tipso({
						        position: 'top',
						        maxWidth: '400',
						        useTitle: true,
						        background: '#444444',
						        color: '#ffffff',
						        width: 'auto'
						    });
						};
						dt_obj.aoColumnDefs = [
						    {"bSortable": false, "aTargets": [0]},
						    {"sClass": "center","aTargets":[0]}, 
						    {"sClass": "sorting_1","aTargets":[1]}, 
						    {"sClass": "form_name","aTargets":[2]}, 
						    {"sClass": "form_entries center","aTargets":[3]},
						    {"sClass": "arf_action_cell","aTargets":[6]} 
						];

						jQuery( '.arf_postcreator_list_form #example' ).dataTable(dt_obj);

					}else{

						ProductTable.clear();
						ProductTable.destroy();

						var dt_obj = {
							"oLanguage": {
								"sProcessing": "",
								"sEmptyTable": jQuery( '#list_order_msg_for_blank_table' ).val(),
								"sZeroRecords": jQuery( '#list_order_msg_for_blank_table' ).val()
							},
							"sDom": '<"H"lfr>t<"footer"ip>',
							"sPaginationType": "four_button",
							"bJQueryUI": true,
							"bPaginate": true,
							"bAutoWidth": false,
							"aoColumnDefs": [{
								"bVisible": false,
								"aTargets": []
							}, {
								"sClass": "arf_action_cell",
								"aTargets": [6]
							}, {
								"bSortable": false,
								"aTargets": [0, 6]
							}],
							"ordering": true,
	        				"order":[[1,'desc']],
							"oColVis": {
								"aiExclude": [0, 6]
							},
						};

						if( __ARF_DB_VERSION >= 4.1 ){
							dt_obj.language = {
								"searchPlaceholder":__ARF_SEARCH_PLACEHOLDER,
								"search":""
							};
						}
					
						var ProductTableNew = jQuery( '#arf_postcreator_forms #example' ).dataTable(dt_obj);
						if( msg.gridData.length > 0 ){
							ProductTableNew.fnAddData( msg.gridData );
						}
					}
				}

                jQuery('#arf_postcreator_forms .arfhelptip').tipso('destroy');

                if (jQuery.isFunction(jQuery().tipso)) {
                    jQuery('#arf_postcreator_forms .arfhelptip').tipso({
                        position: 'top',
                        width: 'auto',
                        maxWidth: '400',
                        useTitle: true,
                        background: '#444444',
                        color: '#ffffff'
                    });
                }
            },
			error: function(msg){
				jQuery( ".arf_loader_icon_wrapper" ).hide();
			}
        }
        );
    }
    jQuery('.arf_modal_overlay.arfactive').removeClass('arfactive');
}

jQuery(document).on('click', '.arf_bulk_delete_transaction_close_btn', function() {
    jQuery('.arf_modal_overlay.arfactive').removeClass('arfactive');
});
